#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/ioctl.h>
#include <fcntl.h>
#include <linux/types.h>
#include <linux/serial.h>    
#include <termios.h>
#include <sys/signal.h>
#include <sys/types.h>

#include "blue.h"

static int serial_fd;

int serial_init(unsigned int baud)
{
	struct termios term;

	serial_fd = open("/dev/ttyS1", O_RDWR | O_NOCTTY);
	if (serial_fd < 0) {
		perror("/dev/ttyS");
		exit(1);
	}

	memset(&term, 0, sizeof(struct termios));

	term.c_cflag = baud | CS8 | CLOCAL | CREAD;
	term.c_iflag = IGNPAR;
//	term.c_oflag = INLCR;
	term.c_oflag = 0;
	term.c_lflag = 0;

	term.c_cc[VTIME] = 0;
	term.c_cc[VMIN] = PACKET_SIZE;

	tcflush(serial_fd, TCIFLUSH);
	tcsetattr(serial_fd, TCSANOW, &term);

	return serial_fd;
}

void serial_flush()
{
	tcflush(serial_fd, TCIFLUSH);
}

void serial_exit()
{
	close(serial_fd);
}
