#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <fcntl.h>
#include <termios.h>
#include <errno.h>

#include <sys/types.h>
#include <sys/stat.h>
#include <sys/ioctl.h>
#include <sys/signal.h>

#include "irda.h"

void init_irda(struct irda_instance *irda)
{
	irda->fd=open(DEVICE_PATH, O_RDWR | O_NDELAY);

	if( irda->fd < 0 )
	{
		printf("%s open failed\n", DEVICE_PATH);
		exit(1);
	}

	ioctl(irda->fd, IRDA_WRITE, NULL);
}

int is_attached(struct irda_instance *irda, int direction)
{

	int ret;

	switch(direction)
	{
		case DOWN_CHECK:

			ioctl(irda->fd, SET_RX_DOWN, NULL);
			ret=ioctl(irda->fd, IRDA_READ, NULL);
			break;

		case LEFT_CHECK:

			ioctl(irda->fd, SET_RX_LEFT, NULL);
			ret=ioctl(irda->fd, IRDA_READ, NULL);
			break;

		case UP_CHECK:

			ioctl(irda->fd, SET_RX_UP, NULL);
			ret=ioctl(irda->fd, IRDA_READ, NULL);
			break;

		case RIGHT_CHECK:

			ioctl(irda->fd, SET_RX_RIGHT, NULL);
			ret=ioctl(irda->fd, IRDA_READ, NULL);
			break;
	}

	if( ret == 0)
		return ATTACHED;
	else
		return DETACHED;
}

void irda_close(struct irda_instance *irda)
{
	close(irda->fd);
}
