#include "common.h"
#include "adc.h"
#include "drop.h"
#include "irda.h"
#include "blue.h"

#define DEBUG
//#define DEBUG_ACC
//#define DEBUG_RECV

int main(int argc, char **argv)
{
	int ret;
	short ts_buf[4];

	pthread_t ts_thread;
	pthread_t acc_thread;
	pthread_t bt_thread;
	void *thread_result;
	struct irda_instance irda;

	unsigned char result_attached=0;
	unsigned char result_detached=0;
	unsigned char dropping_flag=0;


	fb_fd=open(FB_DEV, O_RDWR);
	if( fb_fd < 0 )
    	{
		printf("%s open failed\n",FB_DEV);
		exit(-1);
    	}
	
    	ts_fd=open(TS_DEV, O_RDWR);
    	if( ts_fd < 0 )
    	{
		printf("%s open failed\n",TS_DEV);
		exit(-1);
    	}
	
	sound_fd=open(SOUND_DEV, O_WRONLY);
    	if( sound_fd < 0 )
    	{
		printf("%s open failed\n", SOUND_DEV);
		exit(-1);
    	}
	
	pfbdata=(unsigned short *) mmap(0, FB_SIZE*2, PROT_READ | PROT_WRITE, MAP_SHARED, fb_fd, 0);

	signal(SIGINT, cleanup);

	drop_init_stack();

	init_fb();

	init_loading_image();

	pthread_create(&load_thread, NULL, load_thread_func, NULL);

    	init_drop_app();

	init_drop(); 

	
	pthread_join(load_thread, &thread_result);

	display_drop_info_image();

	init_fb();

	init_irda(&irda);

	bt_init();

	select_drop();
	
	drop( NON_PAINT );
	
	display_drop_image();

	pthread_mutex_init(&mutex, NULL);

	if( pthread_create(&bt_thread, NULL, bt_thread_func, NULL) )
	{
		printf("Create bt_thread failed\n");
		exit(-1);
	}
	
	if( pthread_create(&ts_thread, NULL, ts_thread_func, NULL) )
	{
		printf("Create ts_thread failed\n");
		exit(-1);
	}
	
	if( pthread_create(&acc_thread, NULL, acc_thread_func, NULL) )
	{
		printf("Create acc_thread failed\n");
		exit(-1);
	}


	d_bt.ctl = BT_CTL_DROP_DATA;

	d_tx_data.color=selected_drop;

	d_send();

//	sleep(2);
	
	while(1)
	{
//		usleep(100000);
#ifdef DEBUG
		printf("selected_drop = %d****************************************************************** \n", selected_drop);
		printf("my_color = %d****************************************************************** \n", my_color);
		
		printf("result_attached = %d ", result_attached);
		printf("result_detached = %d ", result_detached);
		printf("dropping_flag = %d \n\n", dropping_flag);
		printf("Send : d_bt.ctl=[%d]", d_bt.ctl); 
		printf(" d_tx_data[ir_attached : %d]", d_tx_data.ir_attached);
		printf(" [tilt : %d]", d_tx_data.tilt);
		printf(" [color : %d]\n\n", d_tx_data.color); 
		printf("Recv : d_bt.ctl=[%d]", d_bt.ctl);
		printf(" d_rx_data[ir_attached : %d]", d_rx_data.ir_attached);
		printf(" [tilt : %d]", d_rx_data.tilt);
		printf(" [color : %d]\n", d_rx_data.color); 
	sleep(1);
#endif

		if( selected_drop == MIX_PAINT )
		{
#ifdef DEBUG
	        printf("=====================MIX_PAINT!================================\n");
#endif
			if( drop_exec && result_attached )	//MIX가 위에
			{
				d_bt.ctl = BT_CTL_DROP_TILT;
				d_tx_data.ir_attached = ATTACHED;
				d_tx_data.tilt = TILT_O;
				d_send();	//PAINT에 대한 정보 전송
				dropping_flag = 1;
				if( d_rx_data.ir_attached && !d_rx_data.tilt && ( d_rx_data.color != MIX_PAINT ) )
				{
#ifdef DEBUG
	        		printf("MIX DROP send!\n");
#endif
					drop_pop();
					drop( keep_color[drop_top] );
					selected_drop = NON_PAINT;
				}
				result_attached = 0;
			}
			else if( result_attached && d_rx_data.tilt && d_rx_data.ir_attached )	//MIX가 평지에
			{
				if( d_rx_data.color != MIX_PAINT )
				{
#ifdef DEBUG
					printf(" real MIX DROP!\n");
#endif
					drop( d_rx_data.color );
					selected_drop = NON_PAINT;
					drop_push(d_rx_data.color);
					dropping_flag =1;
				}
				result_attached = 0;
			}
		}
		else if( selected_drop == RED_PAINT )
		{
#ifdef DEBUG
	        printf("=====================RED_PAINT!================================\n");
#endif
			if( drop_exec && result_attached )	//RED가 위에
		 	{
#ifdef DEBUG
	        	printf("RED Tilt send!\n");
#endif
				d_bt.ctl = BT_CTL_DROP_TILT;
				d_tx_data.ir_attached = ATTACHED;
				d_tx_data.tilt = TILT_O;
	    		d_send();	//RED_attached에 대한 정보 전송
				result_attached = 0;
			}
			else if( result_attached && d_rx_data.tilt && d_rx_data.ir_attached )	//RED가 평지에
			{
				if( d_rx_data.color == MIX_PAINT )
				{
#ifdef DEBUG
	        		printf("RED DROP send!\n");
#endif
					d_bt.ctl = BT_CTL_DROP_DATA;
					d_tx_data.ir_attached = ATTACHED;
					d_tx_data.tilt = TILT_X;
	    			d_send();	//RED_PAINT에 대한 정보 전송
					dropping_flag =1;
				}
				result_attached = 0;
			}
		}
		else if( selected_drop == GREEN_PAINT )
		{
#ifdef DEBUG
	        printf("=====================GREEN_PAINT!================================\n");
#endif
			if( drop_exec && result_attached )	//GREEN이 위에
		 	{
#ifdef DEBUG
	        	printf("GREEN Tilt send!\n");
#endif
				d_bt.ctl = BT_CTL_DROP_TILT;
				d_tx_data.ir_attached = ATTACHED;
				d_tx_data.tilt = TILT_O;
	    		d_send();	//GREEN_attached에 대한 정보 전송
				result_attached = 0;
			}
			else if( result_attached && d_rx_data.tilt && d_rx_data.ir_attached )	//GREEN이 평지에
			{
				if( d_rx_data.color == MIX_PAINT )
				{
#ifdef DEBUG
	        		printf("GREEN DROP send!\n");
#endif
					d_bt.ctl = BT_CTL_DROP_DATA;
					d_tx_data.ir_attached = ATTACHED;
					d_tx_data.tilt = TILT_X;
	    			d_send();	//GREEN_PAINT에 대한 정보 전송
					dropping_flag =1;
				}
				result_attached = 0;
			}
		}
		else if( selected_drop == BLUE_PAINT )
		{
#ifdef DEBUG
	        printf("=====================BLUE_PAINT!================================\n");
#endif
			if( drop_exec && result_attached )	//BLUE가 위에
		 	{
#ifdef DEBUG
	        	printf("BLUE Tilt send!\n");
#endif
				d_bt.ctl = BT_CTL_DROP_TILT;
				d_tx_data.ir_attached = ATTACHED;
				d_tx_data.tilt = TILT_O;
	    		d_send();	//BLUE_attached에 대한 정보 전송
				result_attached = 0;
			}
			else if( result_attached && d_rx_data.tilt && d_rx_data.ir_attached )	//BLUE가 평지에
			{
				if( d_rx_data.color == MIX_PAINT )
				{
#ifdef DEBUG
	        		printf("BLUE DROP send!\n");
#endif
					d_bt.ctl = BT_CTL_DROP_DATA;
					d_tx_data.ir_attached = ATTACHED;
					d_tx_data.tilt = TILT_X;
	    			d_send();	//BLUE_PAINT에 대한 정보 전송
					dropping_flag =1;
				}
				result_attached = 0;
			}
		}
//		pthread_mutex_lock(&mutex);
		if( is_attached(&irda, DOWN_CHECK) || is_attached(&irda, LEFT_CHECK) ||
			is_attached(&irda, UP_CHECK) || is_attached(&irda, RIGHT_CHECK) )
		{
			d_tx_data.ir_attached=ATTACHED;
			if( dropping_flag && !drop_exec )
			{
				d_tx_data.tilt=TILT_X;
	    		d_send();
			}
			result_attached = 1;
		}
		else
			result_attached = 0;
		//if( !is_attached(&irda, DOWN_CHECK) && !is_attached(&irda, LEFT_CHECK) &&
		//	!is_attached(&irda, UP_CHECK) && !is_attached(&irda, RIGHT_CHECK) && !drop_exec && dropping_flag )
		if( !is_attached(&irda, DOWN_CHECK) && !is_attached(&irda, LEFT_CHECK) &&
			!is_attached(&irda, UP_CHECK) && !is_attached(&irda, RIGHT_CHECK) )
		{
			d_tx_data.ir_attached=DETACHED;
			d_bt.ctl = BT_CTL_DROP_DATA;
			if( dropping_flag )
			{
				d_tx_data.tilt=TILT_X;
			}
	    	d_send();	//BLUE_PAINT에 대한 정보 전송
			dropping_flag = 0;
			result_detached = 1;
		}
		else
			result_detached = 0;
//		pthread_mutex_unlock(&mutex);

		display_drop_image();
		
		if(power_off)
		{
			pthread_cancel(ts_thread);
			pthread_join(ts_thread, &thread_result);

			pthread_cancel(acc_thread);
			pthread_join(acc_thread, &thread_result);
		
			pthread_cancel(bt_thread);
			pthread_join(bt_thread, &thread_result);

			cleanup();
		}
	}

	irda_close(&irda);

	cleanup();
}

void init_drop_app(void)
{
	int fd;

	srand(time(NULL));
	my_color=0;
	//my_color=rand()%3;
	
	fd=open_image(POWER_IMAGE_PATH);
	copy_image_to_buff(fd, power, POWER_IMAGE_SIZE);
	close(fd);
	
	fd=open_image(POWER_H_IMAGE_PATH);
	copy_image_to_buff(fd, power_h, POWER_IMAGE_SIZE);
	close(fd);
	
	fd=open_image(INFO_IMAGE_PATH);
	copy_image_to_buff(fd, info, INFO_IMAGE_SIZE);
	close(fd);

	fd=open_image(INFO_H_IMAGE_PATH);
	copy_image_to_buff(fd, info_h, INFO_IMAGE_SIZE);
	close(fd);

	fd=open_image(STOP_IMAGE_PATH);
	copy_image_to_buff(fd, stop, STOP_IMAGE_SIZE);
	close(fd);

	fd=open_image(STOP_H_IMAGE_PATH);
	copy_image_to_buff(fd, stop_h, STOP_IMAGE_SIZE);
	close(fd);
	
	fd=open_image(DROP_MANUAL_IMAGE_PATH);
	copy_image_to_buff(fd, drop_manual, DROP_MANUAL_IMAGE_SIZE);
	close(fd);

	fd=open_image(DROP_RED_IMAGE1_PATH);
	copy_image_to_buff(fd, drop_image1[RED_PAINT-1], DROP_IMAGE_SIZE);
	close(fd);

	fd=open_image(DROP_RED_IMAGE2_PATH);
	copy_image_to_buff(fd, drop_image2[RED_PAINT-1], DROP_IMAGE_SIZE);
	close(fd);

	fd=open_image(DROP_RED_IMAGE3_PATH);
	copy_image_to_buff(fd, drop_image3[RED_PAINT-1], DROP_IMAGE_SIZE);
	close(fd);

	fd=open_image(DROP_GREEN_IMAGE1_PATH);
	copy_image_to_buff(fd, drop_image1[GREEN_PAINT-1], DROP_IMAGE_SIZE);
	close(fd);

	fd=open_image(DROP_GREEN_IMAGE2_PATH);
	copy_image_to_buff(fd, drop_image2[GREEN_PAINT-1], DROP_IMAGE_SIZE);
	close(fd);

	fd=open_image(DROP_GREEN_IMAGE3_PATH);
	copy_image_to_buff(fd, drop_image3[GREEN_PAINT-1], DROP_IMAGE_SIZE);
	close(fd);

	fd=open_image(DROP_BLUE_IMAGE1_PATH);
	copy_image_to_buff(fd, drop_image1[BLUE_PAINT-1], DROP_IMAGE_SIZE);
	close(fd);

	fd=open_image(DROP_BLUE_IMAGE2_PATH);
	copy_image_to_buff(fd, drop_image2[BLUE_PAINT-1], DROP_IMAGE_SIZE);
	close(fd);

	fd=open_image(DROP_BLUE_IMAGE3_PATH);
	copy_image_to_buff(fd, drop_image3[BLUE_PAINT-1], DROP_IMAGE_SIZE);
	close(fd);

	fd=open_wav(POWER_WAV_PATH);
	copy_wav_to_buff(fd, power_wav, POWER_WAV_SIZE);
	close(fd);
	
	fd=open_wav(INFO_WAV_PATH);
	copy_wav_to_buff(fd, info_wav, INFO_WAV_SIZE);
	close(fd);

	fd=open_wav(CLICK_WAV_PATH);
	copy_wav_to_buff(fd, click_wav, CLICK_WAV_SIZE);
	close(fd);
	
	load_complete_flag=1;
}

void display_drop_image(void)
{
	display_image_to_fb(power, POWER_IMAGE_X_SIZE, POWER_IMAGE_Y_SIZE,
			POWER_X_OFFSET, POWER_Y_OFFSET);

	display_image_to_fb(info, INFO_IMAGE_X_SIZE, INFO_IMAGE_Y_SIZE,
			INFO_IMAGE_X_OFFSET, INFO_IMAGE_Y_OFFSET);
	if( selected_drop != MIX_PAINT )	
		display_image_to_fb(drop_image1[my_color-1], DROP_IMAGE_X_SIZE, DROP_IMAGE_Y_SIZE,
			DROP_IMAGE_X_OFFSET, DROP_IMAGE_Y_OFFSET);
}

void display_drop_info_image(void)
{
	int ret;
	short ts_buf[4];
		
	display_image_to_fb(drop_manual, DROP_MANUAL_IMAGE_X_SIZE, DROP_MANUAL_IMAGE_Y_SIZE,
				DROP_MANUAL_IMAGE_X_OFFSET, DROP_MANUAL_IMAGE_Y_OFFSET);
	
	display_image_to_fb(stop, STOP_IMAGE_X_SIZE, STOP_IMAGE_Y_SIZE,
			STOP_IMAGE_X_OFFSET, STOP_IMAGE_Y_OFFSET);

	while(1)
	{
		ret=read(ts_fd, ts_buf, sizeof(ts_buf));
		if( ret < 0 )
		{
	    		printf("Read Touch Screen Data Error\n");
			exit(-1);
		}

		ret=check_click_zone(ts_buf[1], ts_buf[2]);

		if( ts_buf[0] && ret == STOP )
		{

			display_image_to_fb(stop_h, STOP_IMAGE_X_SIZE, STOP_IMAGE_Y_SIZE,
					STOP_IMAGE_X_OFFSET, STOP_IMAGE_Y_OFFSET);
				
			play_wav(click_wav, CLICK_WAV_SIZE);

			break;
		}
	}
}

void init_drop()
{
        int i;

        for (i=1; i<4; i++) 
	{
                
		switch (i) 
		{
                        
			case RED_PAINT:
                                c_table[RED_PAINT-1][0] = makepixel(100, 0, 0); 
                                c_table[RED_PAINT-1][1] = makepixel(110, 0, 0); 
                                c_table[RED_PAINT-1][2] = makepixel(120, 0, 0); 
                                c_table[RED_PAINT-1][3] = makepixel(130, 0, 0); 
                                c_table[RED_PAINT-1][4] = makepixel(140, 0, 0); 
                                c_table[RED_PAINT-1][5] = makepixel(150, 0, 0); 
                                c_table[RED_PAINT-1][6] = makepixel(160, 0, 0); 
                                c_table[RED_PAINT-1][7] = makepixel(170, 0, 0); 
                                c_table[RED_PAINT-1][8] = makepixel(180, 0, 0); 
                                c_table[RED_PAINT-1][9] = makepixel(190, 0, 0); 
                                c_table[RED_PAINT-1][10] = makepixel(200, 0, 0); 
                                c_table[RED_PAINT-1][11] = makepixel(210, 0, 0); 
                                c_table[RED_PAINT-1][12] = makepixel(220, 0, 0); 
                                c_table[RED_PAINT-1][13] = makepixel(230, 0, 0); 
                                c_table[RED_PAINT-1][14] = makepixel(255, 0, 0); 
                                
				break;
                       
			case GREEN_PAINT:
                                c_table[GREEN_PAINT-1][0] = makepixel(0, 100, 0); 
                                c_table[GREEN_PAINT-1][1] = makepixel(0, 110, 0); 
                                c_table[GREEN_PAINT-1][2] = makepixel(0, 120, 0); 
                                c_table[GREEN_PAINT-1][3] = makepixel(0, 130, 0); 
                                c_table[GREEN_PAINT-1][4] = makepixel(0, 140, 0); 
                                c_table[GREEN_PAINT-1][5] = makepixel(0, 150, 0); 
                                c_table[GREEN_PAINT-1][6] = makepixel(0, 160, 0); 
                                c_table[GREEN_PAINT-1][7] = makepixel(0, 170, 0); 
                                c_table[GREEN_PAINT-1][8] = makepixel(0, 180, 0); 
                                c_table[GREEN_PAINT-1][9] = makepixel(0, 190, 0); 
                                c_table[GREEN_PAINT-1][10] = makepixel(0, 200, 0); 
                                c_table[GREEN_PAINT-1][11] = makepixel(0, 210, 0); 
                                c_table[GREEN_PAINT-1][12] = makepixel(0, 220, 0); 
                                c_table[GREEN_PAINT-1][13] = makepixel(0, 230, 0); 
                                c_table[GREEN_PAINT-1][14] = makepixel(0, 255, 0); 
                                
				break;
                        
			case BLUE_PAINT:
                                c_table[BLUE_PAINT-1][0] = makepixel(0, 0, 100);
                                c_table[BLUE_PAINT-1][1] = makepixel(0, 0, 110);
                                c_table[BLUE_PAINT-1][2] = makepixel(0, 0, 120);
                                c_table[BLUE_PAINT-1][3] = makepixel(0, 0, 130);
                                c_table[BLUE_PAINT-1][4] = makepixel(0, 0, 140);
                                c_table[BLUE_PAINT-1][5] = makepixel(0, 0, 150);
                                c_table[BLUE_PAINT-1][6] = makepixel(0, 0, 160);
                                c_table[BLUE_PAINT-1][7] = makepixel(0, 0, 170);
                                c_table[BLUE_PAINT-1][8] = makepixel(0, 0, 180);
                                c_table[BLUE_PAINT-1][9] = makepixel(0, 0, 190);
                                c_table[BLUE_PAINT-1][10] = makepixel(0, 0, 200);
                                c_table[BLUE_PAINT-1][11] = makepixel(0, 0, 210);
                                c_table[BLUE_PAINT-1][12] = makepixel(0, 0, 220);
                                c_table[BLUE_PAINT-1][13] = makepixel(0, 0, 230);
                                c_table[BLUE_PAINT-1][14] = makepixel(0, 0, 255);
                                
				break;
                        
			default: 
				break;
                }
        }
}

void drop(int color)
{
    int c, t, tt, offset;
	for (c=0; c<15; c++)
	{
		for (t=0; t<480; t++) 
		{
			offset = t * 640;

			for (tt=0; tt<640; tt++) 
				*(pfbdata+offset+tt) = c_table[color-1][c];
		}
	}
	drop_push(color);
//	selected_drop = NON_PAINT;
	usleep(100000);
}

void *ts_thread_func(void *arg)
{	
	int ret;
	short ts_buf[4];
	
	while(1)
	{
		if(read(ts_fd,ts_buf,sizeof(ts_buf)) < 0)
		{
	    		printf("Read Touch Screen Data Error\n");
	    		cleanup();
		}	
		
		printf("Press[%d] X[%d] Y[%d] MillSec[%d]\n", ts_buf[0], ts_buf[1], ts_buf[2], ts_buf[3]);

		ret=check_click_zone(ts_buf[1], ts_buf[2]);
	
		if( ts_buf[0] )
		{
			
			switch( ret )
			{
				case POWER_OFF:

					display_image_to_fb(power_h, POWER_IMAGE_X_SIZE, POWER_IMAGE_Y_SIZE,
						POWER_X_OFFSET, POWER_Y_OFFSET);
				
					play_wav(power_wav, POWER_WAV_SIZE);

					display_image_to_fb(power, POWER_IMAGE_X_SIZE, POWER_IMAGE_Y_SIZE,
						POWER_X_OFFSET, POWER_Y_OFFSET);

					power_off=1;

				case INFO:

					acc_key=0;
					
					display_image_to_fb(info_h, INFO_IMAGE_X_SIZE, INFO_IMAGE_Y_SIZE,
							INFO_IMAGE_X_OFFSET, INFO_IMAGE_Y_OFFSET);
					
					play_wav(info_wav, INFO_WAV_SIZE);

					display_drop_info_image();

					init_fb();

					display_drop_image();

					acc_key=1;
					
					break;

				default:

					break;
			}
		}
			
		usleep(100000);
	}
}

void *acc_thread_func(void *arg)
{
	int flag;

	struct struct_accel *acc;
	struct struct_accel_data *data;
	
	acc=acc_init(ACC_CAL_X, ACC_CAL_Y, ACC_CAL_Z);
	data=acc->struct_accel_data;
    	
	while(1)
    	{

#ifdef DEBUG_ACC
		printf("--------------------------\n%lf %lf %lf\n", data->dxv, data->dyv, data->dzv);
		printf("%d %d %d\n", data->rawx, data->rawy, data->rawz);
		printf("%lf %lf %lf\n", data->xtheta, data->ytheta, data->ztheta);
		printf("%lf %lf %lf\n\n", data->xacc, data->yacc, data->zacc);
#endif		
		//if(is_attached(&irda, DOWN_CHECK))
	    //        printf("DOWN ATTACHED!\n");
		if(check_acc(50000, ADC_ACCEL | ACC_DROP))
		//if(check_acc(50000, ADC_ACCEL | ACC_DROP) && (is_attached(&irda, DOWN_CHECK)) )
		{
			if(acc_key)
			{
				pthread_mutex_lock(&mutex);
				drop_exec=1;
				pthread_mutex_unlock(&mutex);
				

//				usleep(100000);
				if(my_color <4)
				{
				display_image_to_fb(drop_image2[my_color-1], DROP_IMAGE_X_SIZE, DROP_IMAGE_Y_SIZE,
						DROP_IMAGE_X_OFFSET, DROP_IMAGE_Y_OFFSET);
				usleep(100000);
			
				display_image_to_fb(drop_image3[my_color-1], DROP_IMAGE_X_SIZE, DROP_IMAGE_Y_SIZE,
						DROP_IMAGE_X_OFFSET, DROP_IMAGE_Y_OFFSET);
				usleep(100000);
				}
				flag=1;
			}
		}else
			if( acc_key && flag==1 )
			{
				pthread_mutex_lock(&mutex);
				drop_exec=0;
				pthread_mutex_unlock(&mutex);

				if(my_color <4)
				display_image_to_fb(drop_image1[my_color-1], DROP_IMAGE_X_SIZE, DROP_IMAGE_Y_SIZE,
						DROP_IMAGE_X_OFFSET, DROP_IMAGE_Y_OFFSET);

				flag=0;
			}
   	}
}


int check_click_zone(short x, short y)
{
	if( x > 560 && x < 630 )
	{
		if( y > 16 && y < 86 )
			return POWER_OFF;
	}

	if( x > 16 && x < 86 )
	{
		if( y > 16 && y < 86 )
			return INFO;
	}

	if( x > 460 && x < 500 )
	{
		if( y > 320 && y < 360)
			return STOP;
	}
	
	return 0;

}

/*****************************************************************************************************
 *
 *  < int check_drop_zone(short x, short y) >
 *
 *  - drop 선택을 위한 터치 스크린 구역을 인식해 주는 함수
 *
 ****************************************************************************************************/
int check_drop_zone(short x, short y)
{
/*
	if( x > 80 && x < 320 )
	{   
		if( y > 170 && y < 430 )
			return DROP_SELECTED;
	}
	else if( x > 330 && x < 570 )
	{   
		if( y > 170 && y < 430 )
			return  MIX_SELECTED;
	}
*/
//640*480 ( 350*350 )
// => x= 145-350-145
// => y= 65-350-65	
	if( x > 145 && x < 315 )
	{   
		if( y > 65 && y < 235 )
			return RED_PAINT;
	}
	if( x > 325 && x < 495 )
	{   
		if( y > 65 && y < 235 )
			return  GREEN_PAINT;
	}
	if( x > 145 && x < 315 )
	{   
		if( y > 245 && y < 415 )
			return  BLUE_PAINT;
	}	
	if( x > 325 && x < 495 )
	{   
		if( y > 245 && y < 415 )
			return  MIX_PAINT;
	}	

	return 0;
}

/********************************************************************************************************
 *
 *  < void select_drop(void) >
 *
 *  -  drop 선택을 위한 인터페이스 함수
 *
 ********************************************************************************************************/
void select_drop(void)
{
	int fd;
	short ts_buf[4];

	fd=open_image(DROP_TITLE_IMAGE_PATH);
	
	copy_image_to_buff(fd, drop_title, DROP_TITLE_IMAGE_SIZE);
	close(fd);

	display_image_to_fb(drop_title, DROP_TITLE_IMAGE_X_SIZE, DROP_TITLE_IMAGE_Y_SIZE,
			DROP_TITLE_IMAGE_X_OFFSET, DROP_TITLE_IMAGE_Y_OFFSET);

	while(1)
	{
		if( read(ts_fd, ts_buf, sizeof(ts_buf)) < 0 )
		{
			printf("Read Touch Screen Data Error\n");
			cleanup();
		}

		printf("Press[%d] X[%d] Y[%d] MillSec[%d]\n", ts_buf[0], ts_buf[1], ts_buf[2], ts_buf[3]);

		selected_drop=check_drop_zone(ts_buf[1], ts_buf[2]);
		my_color = selected_drop;
		printf("sd: %d\n", selected_drop);
		

		if( ts_buf[0] && ( selected_drop == MIX_PAINT || selected_drop == RED_PAINT || 
							selected_drop == GREEN_PAINT|| selected_drop == BLUE_PAINT) )
			break;
	}
}


/********************************************************************************************************
 *
 *  < void data_keep(void) >
 *
 *  -  drop 선택을 위한 인터페이스 함수
 *
 ********************************************************************************************************/
void data_keep(unsigned char recv_data)
{
	if( recv_data != keep_color[drop_top] )
		drop_push(recv_data);
	drop_print_stack();
//	drop_pop();
}


/********************************************************************************************************
 *
 *  < bear_stack > 
 *
 *  -  stack 관련 함수
 *
 ********************************************************************************************************/

void drop_init_stack(void) { 	drop_top = -1; }

void drop_push(int t)
{
	if( drop_top >= KEEP_NUMBER-1){
		printf("keep_color stack Cverflow\n");
	}
	else{
		keep_color[++drop_top] = t;
	}
}

void drop_pop(void)
{
	if( drop_top < 0 ){
		printf("keep_color stack underflow\n");
	}
	else{
		keep_color[drop_top--];
	}
}

void drop_print_stack(void)
{
	int i;
	printf("keep color : ");
	for( i= drop_top; i>= 0; i-- )
		printf("%4d", keep_color[i]);
	printf("\n");
}

void *bt_thread_func(void *arg)
{
	bt_make_packet(&d_bt, BT_MASTER, BT_SLAVE, BT_CTL_DROP);
	bt_send(&d_bt, &d_tx_data, sizeof(d_blue_packet));
#ifdef DEBUG
	printf("Send : d_bt.ctl=[%d]", d_bt.ctl); 
	printf(" d_tx_data[ir_attached : %d]", d_tx_data.ir_attached);
	printf(" [tilt : %d]", d_tx_data.tilt);
	printf(" [color : %d]\n", d_tx_data.color); 
	sleep(1);
#endif

	while(1)
	{
		bt_recv(&d_bt, &d_rx_data, sizeof(d_blue_packet));
#ifdef DEBUG_RECV
		printf("Recv : d_bt.ctl=[%d]", d_bt.ctl);
		printf(" d_rx_data[ir_attached : %d]", d_rx_data.ir_attached);
		printf(" [tilt : %d]", d_rx_data.tilt);
		printf(" [color : %d]\n", d_rx_data.color); 
#endif
		if(d_bt.ctl == BT_CTL_DROP_END)
		{
			pthread_mutex_lock(&mutex);
			power_off = 1;
			pthread_mutex_lock(&mutex);
		}
	}
}

void d_send(void)
{
	if( (d_pre_data.color != d_tx_data.color) || 
		(d_pre_data.ir_attached != d_tx_data.ir_attached) ||
		(d_pre_data.tilt != d_tx_data.tilt) )
	{
		bt_send(&d_bt, &d_tx_data, sizeof(d_blue_packet));
	}
	d_pre_data.color = d_tx_data.color;
	d_pre_data.ir_attached = d_tx_data.ir_attached;
	d_pre_data.tilt = d_tx_data.tilt;
}

void cleanup(void)
{
	init_fb();

	munmap(pfbdata, FB_SIZE*2);

	close(fb_fd);
	close(ts_fd);
	close(sound_fd);

	pthread_mutex_destroy(&mutex);

	acc_exit();

	exit(1);
}
