#include "common.h"
#include "blue.h"
#include "adc.h"
#include "ctl_pocketmon.h"

#define DEBUG

int main(int argc, char **argv)
{
	int ret;
	short ts_buf[4];

	pthread_t ts_thread;
	pthread_t blue_thread;
	pthread_t acc_thread;
	pthread_t wind_thread;
	void *thread_result;

	fb_fd=open(FB_DEV, O_RDWR);
	if( fb_fd < 0 )
    	{
		printf("%s open failed\n", FB_DEV);
		exit(-1);
    	}
	/*
    	ts_fd=open(TS_DEV, O_RDWR);
    	if( ts_fd < 0 )
    	{
		printf("%s open failed\n", TS_DEV);
		exit(-1);
    	}
	*/
	sound_fd=open(SOUND_DEV, O_WRONLY);
    	if( sound_fd < 0 )
    	{
		printf("%s open failed\n", SOUND_DEV);
		exit(1);
    	}
	
	pfbdata=(unsigned short *) mmap(0, FB_SIZE*2, PROT_READ | PROT_WRITE, MAP_SHARED, fb_fd, 0);
	
	signal(SIGINT, cleanup);

	init_fb();

	init_loading_image();

	pthread_create(&load_thread, NULL, load_thread_func, NULL);

	init_pocketmon_app();

	pthread_join(load_thread, &thread_result);

	init_fb();

	display_pocketmon_image();

	pthread_mutex_init(&mutex, NULL);

	//pthread_create(&ts_thread, NULL, ts_thread_func, NULL);
	pthread_create(&blue_thread, NULL, blue_thread_func, NULL);

#ifdef DEBUG
	printf("p_blue_data->race=[%d]\n", p_blue_data->race);
	sleep(3);
#endif
	if(p_blue_data->race == POCKETMON_PICACHU )
		pthread_create(&acc_thread, NULL, acc_thread_func, NULL);
	
	if(p_blue_data->race == POCKETMON_FIRY )
		pthread_create(&wind_thread, NULL, wind_thread_func, NULL);

	while(1)
	{
#ifdef DEBUG
		//printf("Main While loop Start\n");
#endif
		if(attack_flag)
		{
			bt->ctl=BT_CTL_POCKETMON_ATTACK;
			bt_send(bt, p_blue_data, sizeof(p_blue_data));
#ifdef DEBUG
			printf("bt->ctl=[%d]", bt->ctl);
			printf("p_blue_data[id:%d]", p_blue_data->id);
			printf("[race:%d]", p_blue_data->race);
			printf("[attack_damage:%d]\n", p_blue_data->attack_damage);
			sleep(SLEEP_TIME);
#endif
			init_fb();

			display_pocketmon_image();

			pthread_mutex_lock(&mutex);
			attack_flag=0;
			pthread_mutex_unlock(&mutex);
		}

		if(power_off)
		{
			if(p_blue_data->race == POCKETMON_PICACHU)
			{
				pthread_cancel(acc_thread);
				pthread_join(acc_thread, &thread_result);
			}

			if(p_blue_data->race == POCKETMON_FIRY)
			{
				pthread_cancel(wind_thread);
				pthread_join(wind_thread, &thread_result);
			}

			pthread_cancel(blue_thread);
			pthread_join(blue_thread, &thread_result);

			cleanup();
		}
	}
 
	return 0;
}

/**********************************************************************************************************
 *
 *  < void init_pocketmon_app(void) >
 *
 *  - 포켓몬 프로그램에 필요한 이미지, 사운드를 메모리에 로드한다.
 *
 **********************************************************************************************************/
void init_pocketmon_app(void)
{
	int fd;

	bt=(struct blue_packet *)malloc(sizeof(struct blue_packet));
	p_blue_data=(struct pocketmon_blue_packet *)malloc(sizeof(struct pocketmon_blue_packet));

	memset(bt, 0, sizeof(struct blue_packet));
	memset(p_blue_data, 0, sizeof(struct pocketmon_blue_packet));

	bt_init();
	bt_make_packet(bt, BT_MASTER, BT_SLAVE, BT_CTL_POCKETMON);

	while(bt->ctl != BT_CTL_POCKETMON_CONTROL_START)
	{
		bt->ctl=BT_CTL_POCKETMON_CONTROL_RDY;
		bt_send(bt, p_blue_data, sizeof(p_blue_packet));
#ifdef DEBUG
		printf("Send\n");
		printf("bt->ctl=[%d]", bt->ctl);
		printf("p_blue_data[id:%d]", p_blue_data->id);
		printf("[race:%d]", p_blue_data->race);
		printf("[attack_damage:%d]\n", p_blue_data->attack_damage);
#endif
		bt_recv(bt, p_blue_data, sizeof(p_blue_packet));
#ifdef DEBUG
		printf("Recv\n");
		printf("bt->ctl=[%d]", bt->ctl);
		printf("p_blue_data[id:%d]", p_blue_data->id);
		printf("[race:%d]", p_blue_data->race);
		printf("[attack_damage:%d]\n", p_blue_data->attack_damage);
#endif
	}

#ifdef DEBUG
//	p_blue_data->race=POCKETMON_PICACHU;//POCKETMON_FIRY;
#endif
	fd=open_image(GAUGE_BAR_IMAGE1_PATH);
	copy_image_to_buff(fd, gauge_bar[0], GAUGE_BAR_IMAGE_SIZE);
	close(fd);

	fd=open_image(GAUGE_BAR_IMAGE2_PATH);
	copy_image_to_buff(fd, gauge_bar[1], GAUGE_BAR_IMAGE_SIZE);
	close(fd);

	fd=open_image(GAUGE_BAR_IMAGE3_PATH);
	copy_image_to_buff(fd, gauge_bar[2], GAUGE_BAR_IMAGE_SIZE);
	close(fd);

	fd=open_image(GAUGE_BAR_IMAGE4_PATH);
	copy_image_to_buff(fd, gauge_bar[3], GAUGE_BAR_IMAGE_SIZE);
	close(fd);

	fd=open_image(GAUGE_BAR_IMAGE5_PATH);
	copy_image_to_buff(fd, gauge_bar[4], GAUGE_BAR_IMAGE_SIZE);
	close(fd);

	fd=open_image(GAUGE_BAR_IMAGE6_PATH);
	copy_image_to_buff(fd, gauge_bar[5], GAUGE_BAR_IMAGE_SIZE);
	close(fd);

	fd=open_image(GAUGE_BAR_IMAGE7_PATH);
	copy_image_to_buff(fd, gauge_bar[6], GAUGE_BAR_IMAGE_SIZE);
	close(fd);

	switch(p_blue_data->race)
	{
		case POCKETMON_PICACHU:
			
			fd=open_image(SKILL_THUNDER_IMAGE_PATH);
			copy_image_to_buff(fd, skill, SKILL_IMAGE_SIZE);
			close(fd);

			fd=open_image(CHARACTER_PICACHU_IMAGE_PATH);
			copy_image_to_buff(fd, character, CHARACTER_IMAGE_SIZE);
			close(fd);
			break;

		case POCKETMON_FIRY:

			fd=open_image(SKILL_FIRE_IMAGE_PATH);
			copy_image_to_buff(fd, skill, SKILL_IMAGE_SIZE);
			close(fd);

			fd=open_image(CHARACTER_FIRY_IMAGE_PATH);
			copy_image_to_buff(fd, character, CHARACTER_IMAGE_SIZE);
			close(fd);
			break;
#ifdef DEBUG
		default:

			fd=open_image(SKILL_THUNDER_IMAGE_PATH);
			copy_image_to_buff(fd, skill, SKILL_IMAGE_SIZE);
			close(fd);

			fd=open_image(CHARACTER_PICACHU_IMAGE_PATH);
			copy_image_to_buff(fd, character, CHARACTER_IMAGE_SIZE);
			close(fd);
			break;
#endif
	}

	load_complete_flag=1;
}

/*********************************************************************************************
 *
 *  < void display_pocketmon_image(void) >
 *
 *  - 포켓몬  프로그램과 관련된 초기 이미지 파일을 화면에 보여준다
 *
 *********************************************************************************************/
void display_pocketmon_image(void)
{	
	display_image_to_fb(skill, SKILL_IMAGE_X_SIZE, SKILL_IMAGE_Y_SIZE,
			SKILL_IMAGE_X_OFFSET, SKILL_IMAGE_Y_OFFSET);

	display_image_to_fb(character, CHARACTER_IMAGE_X_SIZE, CHARACTER_IMAGE_Y_SIZE,
			CHARACTER_IMAGE_X_OFFSET, CHARACTER_IMAGE_Y_OFFSET);
}

/************************************************************************************************************
 *
 *  < void *ts_thread_func(void *arg) >
 *
 *  -  터치 스크린 인터페이스 함수
 *  	POWER_OFF	: 프로그램 종료
 *  	INFO		: 도움말 표시
 *
 ************************************************************************************************************/
/*
void *ts_thread_func(void *arg)
{
	int ret;
	short ts_buf[4];
	
	while(1)
	{
		if(read(ts_fd,ts_buf,sizeof(ts_buf)) < 0)
		{
	    		printf("Read Touch Screen Data Error\n");
	    		cleanup();
		}	
		
		printf("Press[%d] X[%d] Y[%d] MillSec[%d]\n", ts_buf[0], ts_buf[1], ts_buf[2], ts_buf[3]);

		ret=check_click_zone(ts_buf[1], ts_buf[2]);
	
		if( ts_buf[0] )
		{
			
			switch( ret )
			{
				case POWER_OFF:

					display_image_to_fb(power_h, POWER_IMAGE_X_SIZE, POWER_IMAGE_Y_SIZE,
						POWER_X_OFFSET, POWER_Y_OFFSET);
				
					play_wav(power_wav, POWER_WAV_SIZE);

					display_image_to_fb(power, POWER_IMAGE_X_SIZE, POWER_IMAGE_Y_SIZE,
						POWER_X_OFFSET, POWER_Y_OFFSET);

					pthread_mutex_lock(&mutex);
					power_off=1;
					pthread_mutex_unlock(&mutex);

				case INFO:

					pthread_mutex_lock(&mutex);
					acc_key=0;
					pthread_mutex_unlock(&mutex);
					
					//display_image_to_fb(info_h, INFO_IMAGE_X_SIZE, INFO_IMAGE_Y_SIZE,
					//		INFO_IMAGE_X_OFFSET, INFO_IMAGE_Y_OFFSET);
					
					play_wav(info_wav, INFO_WAV_SIZE);

					//display_drop_info_image();

					//init_fb();

					//display_pocketmon_image();
					
					pthread_mutex_lock(&mutex);
					acc_key=1;
					pthread_mutex_unlock(&mutex);
					
					break;

				default:

					break;
			}
		}
			
		usleep(100000);
	}
}
*/

/*******************************************************************************************************
 *
 *  < void acc_thread_func(void *arg) >
 *
 *  - 피카츄 공격 게이지 상승을 위한 함수
 *  - 흔들게 되면 게이지가 상승한다.
 *
 *******************************************************************************************************/

void *acc_thread_func(void *arg)
{
	struct struct_accel *acc;
	struct struct_accel_data *data;

	acc=acc_init(ACC_CAL_X, ACC_CAL_Y, ACC_CAL_Z);
	data=acc->struct_accel_data;

	while(1)
	{
#ifdef DEBUG
		printf("--------------------------\n%lf %lf %lf\n", data->dxv, data->dyv, data->dzv);
		printf("%d %d %d\n", data->rawx, data->rawy, data->rawz);
		printf("%lf %lf %lf\n", data->xtheta, data->ytheta, data->ztheta);
		printf("%lf %lf %lf\n\n", data->xacc, data->yacc, data->zacc);
#endif
		
		if(acc->check_acc(50000, ADC_ACCEL | ACC_SHAKE))
		{
#ifdef DEBUG
			printf("power_cnt=[%d]\n", power_cnt);
#endif
			if(power_cnt == POWER_CNT_LIMIT)
				power_cnt=0;
			else
				power_cnt++;

			if(power_cnt == POWER_CNT_LIMIT )
			{
				display_image_to_fb(gauge_bar[gauge_cnt], GAUGE_BAR_IMAGE_X_SIZE, GAUGE_BAR_IMAGE_Y_SIZE,
						GAUGE_BAR_IMAGE_X_OFFSET, GAUGE_BAR_IMAGE_Y_OFFSET);

				if(gauge_cnt == GAUGE_MAX)
				{
					pthread_mutex_lock(&mutex);
					attack_flag=1;
					pthread_mutex_unlock(&mutex);
#ifdef DEBUG
					printf("ATTACK!\n");
#endif
					gauge_cnt=0;
					
					sleep(2);
				}
				else
					gauge_cnt++;

			}
		}
	}
}

/*********************************************************************************************************
 *
 *  < void *wind_thread_func(void *arg) >
 *
 *  - 파이리 공격 게이지 상승을 위한 함수
 *  - 바람을 불어 공격 게이지를 상승 시킨다.
 *
 ********************************************************************************************************/

void *wind_thread_func(void *arg)
{
	struct struct_piezo *piezo;
	int piezo_cnt=0;

	piezo=piezo_init(0, 0xff0);

	while(1)
	{
#ifdef DEBUG
		printf("piezo->raw = %d\n", piezo->raw);
#endif
		if(piezo->check_piezo(50000, ADC_PIEZO | PIEZO_WIND))
		{
			if(piezo_cnt < 2)
			{
				piezo_cnt++;
				continue;
			}
			else
				piezo_cnt=0;
			
#ifdef DEBUG
			printf("power_ctn=[%d]\n", power_cnt);
#endif
			if(power_cnt == POWER_CNT_LIMIT)
				power_cnt=0;
			else
				power_cnt++;

			if(power_cnt == POWER_CNT_LIMIT )
			{
				display_image_to_fb(gauge_bar[gauge_cnt], GAUGE_BAR_IMAGE_X_SIZE, GAUGE_BAR_IMAGE_Y_SIZE,
						GAUGE_BAR_IMAGE_X_OFFSET, GAUGE_BAR_IMAGE_Y_OFFSET);

				if(gauge_cnt == GAUGE_MAX)
				{
					piezo->exit();
					pthread_mutex_lock(&mutex);
					attack_flag=1;
					pthread_mutex_unlock(&mutex);
#ifdef DEBUG
					printf("ATTACK!\n");
#endif
					gauge_cnt=0;
					
					sleep(2);
					piezo=piezo_init(0, 0xff0);
				}
				else
					gauge_cnt++;
			}		
		}
	}
}

void *blue_thread_func(void *arg)
{
	struct blue_packet t_bt;
	struct pocketmon_blue_packet t_blue_data;

	while(1)
	{
		recv(&t_bt, &t_blue_data, sizeof(struct pocketmon_blue_packet));
#ifdef DEBUG
		//printf("Recv\n");
		//printf("t_bt.ctl=[%d]", t_bt.ctl);
		//printf("t_blue_data[id:%d]", t_blue_data.id);
		//printf("[race:%d]", t_blue_data.race);
		//printf("[attack_damage:%d]\n", t_blue_data.attack_damage);
#endif
		if(t_bt.ctl == BT_CTL_POCKETMON_END)
		{
			pthread_mutex_lock(&mutex);
				power_off=1;
			pthread_mutex_unlock(&mutex);
		}
	
#ifdef DEBUG
		//printf("blue thread running!\n");
		//sleep(SLEEP_TIME);
#endif
	}
}
/*********************************************************************************************************
 *
 *  < int check_click_zone(short x, short, y) >
 *
 *  - 터치 스크린 디바이스로 부터 얻어온 x, y좌표 값을 받아 설정해 놓은 구역에 합당하면
 *    해당 리턴값을 반환한다
 *
 *********************************************************************************************************/    
/*
int check_click_zone(short x, short y)
{
	if( x > 560 && x < 630 )
	{
		if( y > 16 && y < 86 )
			return POWER_OFF;
	}

	if( x > 16 && x < 86 )
	{
		if( y > 16 && y < 86 )
			return INFO;
	}

	if( x > 460 && x < 500 )
	{
		if( y > 320 && y < 360)
			return STOP;
	}

}
*/

/**********************************************************************************************************
 * 
 * < void cleanup(void) >
 *
 * - 포켓몬 프로그램과 관련된 자원 해제
 *
 **********************************************************************************************************/
void cleanup(void)
{
	init_fb();

	munmap(pfbdata, FB_SIZE*2);

	close(fb_fd);
	close(ts_fd);
	close(sound_fd);

	pthread_mutex_destroy(&mutex);

	free(bt);
	free(p_blue_data);

	exit(1);
}
