#include <termios.h>
#include <errno.h>

#include "common.h"
#include "blue.h"
#include "tet.h"
#include "t_puzzle_cli.h"
#include "irda.h"


int answer_result = 2;
int flag[5] ={ 0};
pthread_mutex_t mutex_work;
struct blue_packet bt;

int main(int argc, char **argv)
{
	struct tet_block tet;
	unsigned int data;
	int no, col, ro;
	int ret;
	int count[4]={ 0};
	int banswer;

	struct irda_instance irda;
	struct ctob ctob1;		

	pthread_t bt_thread;
	void *thread_result;


	fb_fd=open(FB_DEV, O_RDWR);
	if( fb_fd < 0 )
	{
		printf("%s open failed\n", FB_DEV);
		exit(-1);
	}

	sound_fd=open(SOUND_DEV, O_WRONLY);
	if( sound_fd < 0 )
	{
		printf("%s open failed\n", SOUND_DEV);
		exit(-1);
	}

	pfbdata=(unsigned short *) mmap(0, FB_SIZE*2, PROT_READ | PROT_WRITE, MAP_SHARED, fb_fd, 0);

	signal(SIGINT, cleanup);

	init_fb();

	init_loading_image();

	pthread_create(&load_thread, NULL, load_thread_func, NULL);

	init_t_block_client_app();

	pthread_join(load_thread, &thread_result);

	init_fb();

	bt_init();

	bt_make_packet(&bt, BT_MASTER, BT_SLAVE, BT_CTL_TET_IR);

	init_block();

	init_irda(&irda); //irda init


	printf("리씨브대기\n");
	//	bt_recv(&bt, &tet, sizeof(struct tet_block));
	printf("리씨브완료\n");

	no = tet.block_id; col=tet.color; ro = tet.rot;

	make_block(no, ro, col); //s

	display_block();

	printf("bt_thread start\n");
	pthread_create(&bt_thread, NULL, bt_thread_func, NULL);

	//sleep(5);

	printf("main loop start\n");
	while(1)
	{
		//		printf("input answer_result : ");
		//		scanf("%d", &answer_result);
		//		printf("answer_result = %d\n", answer_result);

		//			printf("while start\n");


		ret = is_attached(&irda, DOWN_CHECK);
		if(flag[0] == 0)
		{
						
			if(ret == 1)
			{	
				printf("DOWN ATTACHED!\n");
				count[0]++;
				if(count[0] > 500)
	
				{
					flag[0] = 1;
					ctob1.d_num=DOWN_CHECK; ctob1.d_id = BT_MASTER;
					bt_send(&bt, &ctob1, sizeof(struct ctob));
//					sleep(SLEEP_TIME);
					count[0] = 0;

				}

				if(bt.data[0] == 1001)
				{
					memset(flag, 1, sizeof(flag));
					printf("flagmemset: %d\n", flag[0]);
					flag[0] = 1;
				}
				//	   	bt_recv(&bt, &banswer, sizeof(int));

				//	    	if(banswer == 1001)
				//	    		answer_result = 1; 



			}

		}

		if(ret == 0 && bt.data[0] != 1001)
		{
			flag[0] = 0;					
		}


		ret = is_attached(&irda, LEFT_CHECK);
		if(flag[1] == 0)
		{
			if(ret == 1)
			{
				printf("LEFT ATTACHED!\n");
				count[1]++;
				if(count[1] > 500)
				{
					flag[1] = 1;
					ctob1.d_num=LEFT; ctob1.d_id = BT_MASTER;
					bt_send(&bt, &ctob1, sizeof(struct ctob));
					count[1] = 0;
//					sleep(SLEEP_TIME);




					//	    		bt_recv(&bt, &banswer, sizeof(int));
				}
					if(bt.data[0] == 1001)
					{
						memset(flag, 1, sizeof(flag));
						flag[1] = 1;
					}

					//	    			answer_result = 1; 

					
				//break;


				printf("flag ==L 1\n");
				printf("%d", flag[4]);
			}
		}
		if(ret == 0 && bt.data[0] != 1001)
		{
				flag[1] = 0;
		}


		ret=is_attached(&irda, UP_CHECK);
		if(flag[2] == 0)
		{
			if(ret == 1)
			{
				printf("UP ATTACHED!\n");
				count[2]++;
				if(count[2] > 500)
				{
					ctob1.d_num=UP_CHECK; ctob1.d_id = BT_MASTER;
					bt_send(&bt, &ctob1, sizeof(struct ctob));
					count[2] = 0;
//					sleep(SLEEP_TIME);
					//	bt_recv(&bt, &banswer, sizoef(int));

					//	if(banswer == 1001)
					//		answer_result = 1; 

				}
				//	break;

				if(bt.data[0] == 1001)
				{
					flag[2] = 1;
					memset(flag, 1, sizeof(flag));
				}
				//flag[2] = 1;
				printf("flag == U 1\n");
				printf("%d", flag[4]);
			}
		}
		
		if(ret == 0 && bt.data[0] != 1001)
		{

				flag[2] = 0;
		}	




		ret=is_attached(&irda, RIGHT_CHECK);
		if(flag[3] == 0)
		{
			if(ret == 1)
			{
				printf("RIGHT ATTAHCED!\n");
				count[3]++;
				if(count[3] > 500)
				{
					flag[3] = 1;
					ctob1.d_num = RIGHT; ctob1.d_id = BT_MASTER;
					bt_send(&bt, &ctob1, sizeof(struct ctob));
					count[3] = 0;
//					sleep(SLEEP_TIME);

					//	    	bt_recv(&bt, &banswer, sizeof(int));

					//	    	if(banswer == 1001)
					//    		answer_result = 1; 

				}
				if(bt.data[0] == 1001)
				{
					memset(flag, 1, sizeof(flag));
					flag[3] = 1;
				}
				//	break;
				//flag[3] = 1;
				printf("flag ==R 1\n");
				printf("%d", flag[4]);
			
			}	
			
		}


		if(ret == 0 && bt.data[0] != 1001)
		{
				flag[3] = 0;

		}



		if(flag[4] == 1)
		{
			switch(answer_result)
			{
				//printf("%d\n", answer_result);

				case 0:
					display_image_to_fb(t_no, T_OK_NO_IMAGE_X_SIZE, T_OK_NO_IMAGE_Y_SIZE,
							T_OK_NO_IMAGE_X_OFFSET, T_OK_NO_IMAGE_Y_OFFSET);


					play_wav(t_no_wav, T_NO_WAV_SIZE);
					sleep(SLEEP_TIME+1);
					printf("%d\n", answer_result);


					init_fb();

					display_block();

					flag[4] = 0;

					answer_result = 2;

					break;


				case 1:

					display_image_to_fb(t_ok, T_OK_NO_IMAGE_X_SIZE, T_OK_NO_IMAGE_Y_SIZE,
							T_OK_NO_IMAGE_X_OFFSET, T_OK_NO_IMAGE_Y_OFFSET);

					play_wav(t_ok_wav, T_OK_WAV_SIZE);
					sleep(SLEEP_TIME+1);

					printf("%d\n", answer_result);

					init_fb();

					flag[4] = 0; 

					answer_result = 2;

					break;
			}
		}
		//		printf("\n");

		if(power_off)
		{
			pthread_cancel(bt_thread);
			pthread_join(bt_thread, &thread_result);

			cleanup();
		}
	}

	cleanup();
}

void init_t_block_client_app(void)
{
	int fd;

	fd=open_image(RED_BLOCK_B_IMAGE_PATH);
	copy_image_to_buff(fd, red_block_b, BLOCK_IMAGE_SIZE);
	close(fd);

	fd=open_image(GREEN_BLOCK_B_IMAGE_PATH);
	copy_image_to_buff(fd, green_block_b, BLOCK_IMAGE_SIZE);
	close(fd);

	fd=open_image(BLUE_BLOCK_B_IMAGE_PATH);
	copy_image_to_buff(fd, blue_block_b, BLOCK_IMAGE_SIZE);
	close(fd);

	fd=open_image(YELLOW_BLOCK_B_IMAGE_PATH);
	copy_image_to_buff(fd, yellow_block_b, BLOCK_IMAGE_SIZE);
	close(fd);


	fd=open_image(T_OK_IMAGE_PATH);
	copy_image_to_buff(fd, t_ok, T_OK_NO_IMAGE_SIZE);
	close(fd);

	fd=open_image(T_NO_IMAGE_PATH);
	copy_image_to_buff(fd, t_no, T_OK_NO_IMAGE_SIZE);
	close(fd);

	fd=open_wav(T_OK_WAV_PATH);
	copy_wav_to_buff(fd, t_ok_wav, T_OK_WAV_SIZE);
	close(fd);

	fd=open_wav(T_NO_WAV_PATH);
	copy_wav_to_buff(fd, t_no_wav, T_NO_WAV_SIZE);
	close(fd);

	load_complete_flag=1;
}

void init_block(void)
{
	int i, j, k;
	int color;
	int x_offset=0;
	int y_offset=0;

	for( i=0 ; i < 3 ; i++ )
	{
		for( j=0 ; j < 3 ; j++ )
		{
			block[i][j].flag=0;
			block[i][j].color=COLOR_RED;
			block[i][j].x_offset=PUZZLE_BASE_X_OFFSET+x_offset;
			block[i][j].y_offset=PUZZLE_BASE_Y_OFFSET+y_offset;

			x_offset=x_offset+100;
		}

		x_offset=0;
		y_offset=y_offset+100;
	}
}

void make_block(int block_no, int color, int rotation_cnt)
{

	switch(block_no)
	{
		case PUZZLE_BLOCK_NO1:

			block[0][0].flag=1;
			block[0][1].flag=1;
			block[1][0].flag=1;
			block[1][1].flag=1;

			block[0][0].color=color;
			block[0][1].color=color;
			block[1][0].color=color;
			block[1][1].color=color;

			break;

		case PUZZLE_BLOCK_NO2:

			block[0][0].flag=1;
			block[0][1].flag=1;
			block[0][2].flag=1;
			block[1][2].flag=1;
			block[2][2].flag=1;

			block[0][0].color=color;
			block[0][1].color=color;
			block[0][2].color=color;
			block[1][2].color=color;
			block[2][2].color=color;

			rotate_block(rotation_cnt);

			break;

		case PUZZLE_BLOCK_NO3:

			block[1][0].flag=1;
			block[1][1].flag=1;
			block[1][2].flag=1;

			block[1][0].color=color;
			block[1][1].color=color;
			block[1][2].color=color;

			rotate_block(rotation_cnt);

			break;

		case PUZZLE_BLOCK_NO4:

			block[0][1].flag=1;
			block[1][0].flag=1;
			block[1][1].flag=1;
			block[1][2].flag=1;

			block[0][1].color=color;
			block[1][0].color=color;
			block[1][1].color=color;
			block[1][2].color=color;

			rotate_block(rotation_cnt);

			break;

		case PUZZLE_BLOCK_NO5:

			block[0][0].flag=1;
			block[0][1].flag=1;
			block[0][2].flag=1;
			block[1][0].flag=1;
			block[1][2].flag=1;

			block[0][0].color=color;
			block[0][1].color=color;
			block[0][2].color=color;
			block[1][0].color=color;
			block[1][2].color=color;

			rotate_block(rotation_cnt);

			break;

		case PUZZLE_BLOCK_NO6:

			block[0][0].flag=1;
			block[0][1].flag=1;
			block[0][2].flag=1;
			block[1][1].flag=1;
			block[1][2].flag=1;
			block[2][1].flag=1;
			block[2][2].flag=1;

			block[0][0].color=color;
			block[0][1].color=color;
			block[0][2].color=color;
			block[1][1].color=color;
			block[1][2].color=color;
			block[2][1].color=color;
			block[2][2].color=color;

			rotate_block(rotation_cnt);

			break;

		case PUZZLE_BLOCK_NO7:

			block[0][0].flag=1;
			block[0][1].flag=1;
			block[0][2].flag=1;
			block[1][1].flag=1;
			block[2][1].flag=1;

			block[0][0].color=color;
			block[0][1].color=color;
			block[0][2].color=color;
			block[1][1].color=color;
			block[2][1].color=color;

			rotate_block(rotation_cnt);

			break;
	}

}

void display_block(void)
{

	int i, j;
	int color;

	for( i=0 ; i < 3 ; i++ )
	{
		for( j=0 ; j < 3 ; j++ )
		{
			if( block[i][j].flag == 1 )
			{
				color=block[i][j].color;

				switch(color)
				{
					case COLOR_RED:

						display_image_to_fb(red_block_b, BLOCK_IMAGE_X_SIZE, BLOCK_IMAGE_Y_SIZE,
								block[i][j].x_offset, block[i][j].y_offset);
						break;

					case COLOR_GREEN:

						display_image_to_fb(green_block_b, BLOCK_IMAGE_X_SIZE, BLOCK_IMAGE_Y_SIZE,
								block[i][j].x_offset, block[i][j].y_offset);
						break;

					case COLOR_BLUE:

						display_image_to_fb(blue_block_b, BLOCK_IMAGE_X_SIZE, BLOCK_IMAGE_Y_SIZE,
								block[i][j].x_offset, block[i][j].y_offset);
						break;

					case COLOR_YELLOW:

						display_image_to_fb(yellow_block_b, BLOCK_IMAGE_X_SIZE,BLOCK_IMAGE_Y_SIZE,
								block[i][j].x_offset, block[i][j].y_offset);
						break;
				}
			}
		}
	}
}

void rotate_block(int rotation_cnt)
{
	int i, j, k, l;
	int c;
	struct puzzle_block temp_block[3][3];

	if( rotation_cnt == 0)
		return;

	memcpy(temp_block, block, sizeof(struct puzzle_block)*9);

	for( c=0 ; c < rotation_cnt ; c++ )
	{
		for( i=0, k=2; i<3 ; i++, k-- )
		{
			for( j=0, l=0 ; j < 3 ; j++, l++ )
			{
				temp_block[l][k].flag=block[i][j].flag;
				temp_block[l][k].color=block[i][j].color;
			}
		}

		memcpy(block, temp_block, sizeof(struct puzzle_block)*9);
	}
}

void *bt_thread_func(void *arg)
{
	struct blue_packet bt;
	struct tet_block tet;
	unsigned int data;


	while(1)
	{

		bt_recv(&bt, &tet, sizeof(struct tet_block));

		if( bt.ctl == BT_CTL_TET)
		{
			if( bt.data[0] == BT_CTL_TET_END )
			{
				pthread_mutex_lock(&mutex_work);
				power_off=1;
				pthread_mutex_unlock(&mutex_work);
			}			

			else if(bt.data[0] == 1001)
			{
				printf("bt data %d\n", bt.data[0]);
				pthread_mutex_lock(&mutex_work);
				flag[4] = 1;
				answer_result = 1;
				pthread_mutex_unlock(&mutex_work);
			}

			else if(bt.data[0] ==1002)
			{
				printf("bt data %d\n", bt.data[0]);
				pthread_mutex_lock(&mutex_work);
				flag[4] = 1;
				answer_result = 0;
				pthread_mutex_unlock(&mutex_work);

			}

		}
		else if( bt.ctl == BT_CTL_TET_DATA )
		{
			init_block();

			make_block(tet.block_id, tet.color, tet.rot);
			printf("recevie %d %d %d\n", tet.block_id, tet.color, tet.rot);
			sleep(2);

			init_fb();

			display_block();

		}




	}
}

void cleanup(void)
{
	init_fb();

	munmap(pfbdata, FB_SIZE*2);

	close(fb_fd);
	close(ts_fd);
	close(sound_fd);

	bt_exit();

	exit(1);
}


