#include <stdio.h>
#include <termios.h>
#include <errno.h>

#include "common.h"
#include "blue.h"
#include "tet.h"
#include "t_puzzle_serv.h"
#include "irda.h"

int main(int argc, char **argv)
{
	pthread_t ts_thread;
	pthread_t bt_thread;
	void *thread_result;

	int direc, bid, cdir;
	int count[4] ={ 0};
	int flag[4]={ 0};
	int btos[4];
	int ret ;
/*	struct irda_devlist devlist;
        struct irda_devs irda_dev;
        struct irda_socket_address sa; 
        struct irda_thread Thread_ID;*/

	struct irda_instance irda;
	struct stob stb;
	struct blue_packet dda;
		
	//irda.num = BT_MASTER;
		
	fb_fd=open(FB_DEV, O_RDWR);
	if( fb_fd < 0 )
    	{
		printf("%s open failed\n", FB_DEV);
		exit(-1);
    	}

    	ts_fd=open(TS_DEV, O_RDWR);
    	if( ts_fd < 0 )
    	{
		printf("%s open failed\n", TS_DEV);
		exit(-1);
    	}
    	
	sound_fd=open(SOUND_DEV, O_WRONLY);
    	if( sound_fd < 0 )
    	{
		printf("%s open failed\n", SOUND_DEV);
		exit(-1);
		}

	pfbdata=(unsigned short *) mmap(0, FB_SIZE*2, PROT_READ | PROT_WRITE, MAP_SHARED, fb_fd, 0);

	signal(SIGINT, cleanup); //ctrl+c 가 들어왔을때 가로 체기

	init_fb();

	init_loading_image();

	pthread_create(&load_thread, NULL, load_thread_func, NULL); //첫번째 변수는 pthread_t를 가르치는 포인터 다음은 스레드의 특성 
																//다음은 start routine(load image 쓰레드 생성)

	init_t_block_server_app(); //대기화면 이미지 copy to buff

	pthread_join(load_thread, &thread_result); //첫번째인자는 스레드 식별자 다음 인자는 반환값을 반환 하는 인자

	//display_t_puzzle_info_image();

	init_fb();

	bt_init();

	init_irda(&irda);//irda init//check 해 볼것/////////////////////////
		
	bt_make_packet(&bt, BT_MASTER, BT_SLAVE, BT_CTL_TET);

	data=BT_CTL_TET_START;

	bt_send(&bt, &data, sizeof(int));

	data=BT_CTL_TET_SET; //문제 만들준비 생성

	bt_send(&bt, &data, sizeof(int));

	printf("bt_recv\n");

	bt_recv(&bt, tet, sizeof(struct tet_block)*4);

	printf("bt_recv clean\n");
	
	make_puzzle_map(tet);

	display_t_puzzle_image();

//	all_recv(&irda_dev); // ir

	pthread_create(&ts_thread, NULL, ts_thread_func, NULL);

	bt_make_packet(&bt, BT_MASTER, BT_SLAVE, BT_CTL_TET_IR);

	stb.d_id = BT_MASTER;

//	pthread_create(&blue_thread, NULL, blue_thread_func, NULL);

//	pthread_create(&bt_thread, NULL, bt_thread_func, NULL);

//	bt_make_packet(&bt, BT_MASTER, BT_SLAVE, BT_CTL_TET_SET);
	while(1)
	{
		ret = is_attached(&irda, DOWN_CHECK);
		//printf("while start\n");
		if(flag[0] == 0)
		{
			
			printf("\n--------down---ret = %d---------------------------------------------------------\n", ret);

			if(ret == ATTACHED)
			{
				count[0]++;

				if(count[0] > 10)
				{
					flag[0] = 1;
					printf("Down\n");
					stb.d_num = DOWN_CHECK;				
					bt_send(&bt, &stb, sizeof(struct stob));
					bt_recv(&dda, &btos[0], sizeof(int));
					count[0] = 0;
				}

				printf("\n---------------------DOWN---btos = %d------------------------------\n", btos);
				if(btos[0] == 1001)
				{
					flag[0] = 1;
					make_puzzle_block(BOTTOM, &tet[0], 1, 1);
					display_t_puzzle_image();
				}
				
			}			
			
				
		}
			if(ret == DETACHED && btos[0] != 1001)
			{
				flag[0] = 0;
			}

		

		ret =is_attached(&irda, UP_CHECK);
		if(flag[1] == 0)
		{
			printf("\n--------up---ret = %d---------------------------------------------------------\n", ret);
			if(ret == ATTACHED)// Attach
			{
				
				count[1]++;
				if(count[1] > 10)
				{
					flag[1] = 1;
					printf("UP\n");
					stb.d_num = UP_CHECK;				
					bt_send(&bt, &stb, sizeof(struct stob));
					bt_recv(&dda, &btos[1], sizeof(int));
					count[1] = 0;
				}	
			 
				printf("\n------------------------------UP -btos = %d----------------------------\n", btos);
			 	if(btos[1] == 1001)
				{
					flag[1] = 1;
					make_puzzle_block(TOP, &tet[2], 1, 2);
		
					display_t_puzzle_image();
				}
				
			}

			


		}	 	
			if(ret == DETACHED &&  btos[1] != 1001) // Dettache 
			{
			 	 flag[1] = 0;
			}

		ret = is_attached(&irda, LEFT_CHECK);
		if(flag[2] == 0)
		{
			printf("\n-----LEFT------ret = %d---------------------------------------------------------\n", ret);
			if(ret == ATTACHED)
			{
				count[2]++;
				if(count[2] > 10)
				{
					flag[2] = 1;
					printf("Left\n");
					stb.d_num = LEFT;
					bt_send(&bt, &stb, sizeof(struct stob));
					bt_recv(&dda, &btos[2], sizeof(int));
					printf("\n-------------------------------Left btos = %d----------------------------\n", btos);
					count[2] = 0;
					
				}

				if(btos[2] == 1001)
				{
					flag[2] = 1;
					make_puzzle_block(LEFT, &tet[1], 1, 3);
					display_t_puzzle_image();
				}
				
			}
			
							
		}	
			if(ret == DETACHED && btos[2] != 1001)
			{
				flag[2] = 0;
			}


		ret =is_attached(&irda, RIGHT_CHECK);
		if(flag[3] == 0)
		{
			printf("\n-------Right----------- ret = %d---------------------------------------------------------\n", ret);
			if(ret == ATTACHED)
			{
				count[3]++;
				if(count[3] > 10)
				{
					flag[3] = 1;
					printf("Right\n");
					stb.d_num = RIGHT;
					bt_send(&bt, &stb, sizeof(struct stob));
					bt_recv(&dda, &btos[3], sizeof(int));
					printf("\n------------------------------Right btos = %d----------------------------\n", btos);
					count[3] = 0;
				}

				if(btos[3] == 1001)
			  	{
			   		flag[3] =1;
				 	make_puzzle_block(RIGHT, &tet[3], 1, 4);
					display_t_puzzle_image();
				}
				
			}

		
		
		}
		if(ret == DETACHED && btos[3] != 1001)
		{
				flag[3] = 0;
		}



				
/*		if(ISSTATUS(SOUTH) == ATTACHED)
			check_answer_block(BOTTOM, &irda_dev);
		else if(ISSTATUS(WEST) == ATTACHED)
			check_answer_block(LEFT, &irda_dev);
		else if(ISSTATUS(NORTH) == ATTACHED)
			check_answer_block(TOP, &irda_dev);
		else if(ISSTATUS(EAST) == ATTACHED)
		check_answer_block(RIGHT, &irda_dev);*/

//		printf("????? ");
//		scanf("%d %d %d", &direc, &bid, &cdir);
		//check_answer_block(direc, bid, cdir);

		if(t_puzzle_top && t_puzzle_right && t_puzzle_left && t_puzzle_bottom)
			t_puzzle_complete = 1;



		if(power_off)
		{

			pthread_cancel(ts_thread);
			pthread_join(ts_thread, &thread_result);

			bt_make_packet(&bt, BT_MASTER, BT_SLAVE, BT_CTL_TET);

			data=BT_CTL_TET_END;

			bt_send(&bt, &data, sizeof(int));

//			clean_exit(&irda_dev, &Thread_ID); //ir

//			pthread_cancel(bt_thread);
//			pthread_join(bt_thread, &thread_result);

			cleanup();
		}
	}

//	clean_exit(&irda_dev, &Thread_ID); //ir
	cleanup();
}

void init_t_block_server_app(void)
{
	int fd;
	
	fd=open_image(POWER_IMAGE_PATH);
	copy_image_to_buff(fd, power, POWER_IMAGE_SIZE);
	close(fd);
	
	fd=open_image(POWER_H_IMAGE_PATH);
	copy_image_to_buff(fd, power_h, POWER_IMAGE_SIZE);
	close(fd);
	
	fd=open_image(INFO_IMAGE_PATH);
	copy_image_to_buff(fd, info, INFO_IMAGE_SIZE);
	close(fd);

	fd=open_image(INFO_H_IMAGE_PATH);
	copy_image_to_buff(fd, info_h, INFO_IMAGE_SIZE);
	close(fd);

	fd=open_image(STOP_IMAGE_PATH);
	copy_image_to_buff(fd, stop, STOP_IMAGE_SIZE);
	close(fd);

	fd=open_image(STOP_H_IMAGE_PATH);
	copy_image_to_buff(fd, stop_h, STOP_IMAGE_SIZE);
	close(fd);
	/*
	fd=open_image(SHOCK_MANUAL_IMAGE_PATH);
	copy_image_to_buff(fd, shock_manual, SHOCK_MANUAL_IMAGE_SIZE);
	close(fd);
	*/
	fd=open_image(RED_BLOCK_IMAGE_PATH);
	copy_image_to_buff(fd, red_block, BLOCK_IMAGE_SIZE);
	close(fd);

	fd=open_image(GREEN_BLOCK_IMAGE_PATH);
	copy_image_to_buff(fd, green_block, BLOCK_IMAGE_SIZE);
	close(fd);

	fd=open_image(BLUE_BLOCK_IMAGE_PATH);
	copy_image_to_buff(fd, blue_block, BLOCK_IMAGE_SIZE);
	close(fd);
	
	fd=open_image(YELLOW_BLOCK_IMAGE_PATH);
	copy_image_to_buff(fd, yellow_block, BLOCK_IMAGE_SIZE);
	close(fd);
	
	fd=open_wav(POWER_WAV_PATH);
	copy_wav_to_buff(fd, power_wav, POWER_WAV_SIZE);
	close(fd);
	
	fd=open_wav(INFO_WAV_PATH);
	copy_wav_to_buff(fd, info_wav, INFO_WAV_SIZE);
	close(fd);

	fd=open_wav(CLICK_WAV_PATH);
	copy_wav_to_buff(fd, click_wav, CLICK_WAV_SIZE);
	close(fd);
	
	load_complete_flag=1;
}

void make_puzzle_map(struct tet_block tet[4])
{
	int i, j;
	int color;
	int x_offset=0;
	int y_offset=0;

	srand(time(NULL));

	for( i=0 ; i < 9 ; i++ )
	{
		for( j=0 ; j < 9 ; j++ )
		{
			color=(rand()%4)+1;

			map[i][j].flag=1;
			map[i][j].color=color;
			map[i][j].x_offset=PUZZLE_BASE_X_OFFSET+x_offset;
			map[i][j].y_offset=PUZZLE_BASE_Y_OFFSET+y_offset;

			x_offset=x_offset+48;
		}

		x_offset=0;
		y_offset=y_offset+48;
	}

	make_puzzle_block(BOTTOM, &tet[0], 0, 0);
	make_puzzle_block(LEFT, &tet[1], 0, 0);
	make_puzzle_block(TOP, &tet[2], 0, 0);
	make_puzzle_block(RIGHT, &tet[3], 0,0);
}

void make_puzzle_block(int direction, struct tet_block *tet, int flag, int cflag)
{
	int i, j;
	int select;

	select=tet->correct%2;

	switch(direction)
	{
		case TOP:

			switch(tet->block_id)
			{

				case PUZZLE_BLOCK_NO1:

					map[0][3].flag=flag;
					map[0][4].flag=flag;
					map[1][3].flag=flag;
					map[1][4].flag=flag;

					map[0][3].color=cflag;
					map[0][4].color=cflag;
					map[1][3].color=cflag;
					map[1][4].color=cflag;
					break;

				case PUZZLE_BLOCK_NO2:

					map[0][3].flag=flag;
					map[0][4].flag=flag;
					map[0][5].flag=flag;

					map[0][3].color=cflag;
					map[0][4].color=cflag;
					map[0][5].color=cflag;
					
					if( select == 0 )
					{
						map[1][5].flag=flag;
						map[2][5].flag=flag;

						map[1][5].color=cflag;
						map[2][5].color=cflag;

					}else
					{
						map[1][3].flag=flag;
						map[2][3].flag=flag;

						map[1][3].color=cflag;
						map[2][3].color=cflag;
					}

					break;

				case PUZZLE_BLOCK_NO3:

					if( select == 0 )
					{
						map[0][3].flag=flag;
						map[0][4].flag=flag;
						map[0][5].flag=flag;

						map[0][3].color=cflag;
						map[0][4].color=cflag;
						map[0][5].color=cflag;
					}else
					{
						map[0][4].flag=flag;
						map[1][4].flag=flag;
						map[2][4].flag=flag;

						map[0][4].color=cflag;
						map[1][4].color=cflag;
						map[2][4].color=cflag;
					}

					break;

				case PUZZLE_BLOCK_NO4:

					map[0][3].flag=flag;
					map[0][4].flag=flag;
					map[0][5].flag=flag;
					map[1][4].flag=flag;

					map[0][3].color=cflag;
					map[0][4].color=cflag;
					map[0][5].color=cflag;
					map[1][4].color=cflag;

					break;

				case PUZZLE_BLOCK_NO5:

					map[0][3].flag=flag;
					map[0][4].flag=flag;
					map[0][5].flag=flag;
					map[1][3].flag=flag;
					map[1][5].flag=flag;

					map[0][3].color=cflag;
					map[0][4].color=cflag;
					map[0][5].color=cflag;
					map[1][3].color=cflag;
					map[1][5].color=cflag;

					break;

				case PUZZLE_BLOCK_NO6:

					map[0][3].flag=flag;
					map[0][4].flag=flag;
					map[0][5].flag=flag;

					map[0][3].color=cflag;
					map[0][4].color=cflag;
					map[0][5].color=cflag;

					if( select == 0 )
					{
						map[1][4].flag=flag;
						map[1][5].flag=flag;
						map[2][4].flag=flag;
						map[2][5].flag=flag;

						map[1][4].color=cflag;
						map[1][5].color=cflag;
						map[2][4].color=cflag;
						map[2][5].color=cflag;
					}else
					{
						map[1][3].flag=flag;
						map[1][4].flag=flag;
						map[1][5].flag=flag;
						map[2][3].flag=flag;

						map[1][3].color=cflag;
						map[1][4].color=cflag;
						map[1][5].color=cflag;
						map[2][3].color=cflag;
					}

					break;

				case PUZZLE_BLOCK_NO7:

					map[0][3].flag=flag;
					map[0][4].flag=flag;
					map[0][5].flag=flag;
					map[1][4].flag=flag;
					map[2][4].flag=flag;

					map[0][3].color=cflag;
					map[0][4].color=cflag;
					map[0][5].color=cflag;
					map[1][4].color=cflag;
					map[2][4].color=cflag;

					break;
			}

			break;

		case RIGHT:
			
			switch(tet->block_id)
			{
				case PUZZLE_BLOCK_NO1:

					map[3][7].flag=flag;
					map[3][8].flag=flag;
					map[4][7].flag=flag;
					map[4][8].flag=flag;

					map[3][7].color=cflag;
					map[3][8].color=cflag;
					map[4][7].color=cflag;
					map[4][8].color=cflag;

					break;

				case PUZZLE_BLOCK_NO2:

					if( select == 0 )
					{
						map[3][8].flag=flag;
						map[4][8].flag=flag;
						map[5][6].flag=flag;
						map[5][7].flag=flag;
						map[5][8].flag=flag;

						map[3][8].color=cflag;
						map[4][8].color=cflag;
						map[5][6].color=cflag;
						map[5][7].color=cflag;
						map[5][8].color=cflag;
					}else
					{
						map[3][6].flag=flag;
						map[3][7].flag=flag;
						map[3][8].flag=flag;
						map[4][8].flag=flag;
						map[5][8].flag=flag;

						map[3][6].color=cflag;
						map[3][7].color=cflag;
						map[3][8].color=cflag;
						map[4][8].color=cflag;
						map[5][8].color=cflag;
					}

					break;

				case PUZZLE_BLOCK_NO3:

					if( select == 0 )
					{
						map[3][8].flag=flag;
						map[4][8].flag=flag;
						map[5][8].flag=flag;

						map[3][8].color=cflag;
						map[4][8].color=cflag;
						map[5][8].color=cflag;
					}else
					{
						map[4][6].flag=flag;
						map[4][7].flag=flag;
						map[4][8].flag=flag;

						map[4][6].color=cflag;
						map[4][7].color=cflag;
						map[4][8].color=cflag;
					}
					
					break;

				case PUZZLE_BLOCK_NO4:

					map[3][8].flag=flag;
					map[4][7].flag=flag;
					map[4][8].flag=flag;
					map[5][8].flag=flag;

					map[3][8].color=cflag;
					map[4][7].color=cflag;
					map[4][8].color=cflag;
					map[5][8].color=cflag;

					break;

				case PUZZLE_BLOCK_NO5:

					map[3][7].flag=flag;
					map[3][8].flag=flag;
					map[4][8].flag=flag;
					map[5][7].flag=flag;
					map[5][8].flag=flag;

					map[3][7].color=cflag;
					map[3][8].color=cflag;
					map[4][8].color=cflag;
					map[5][7].color=cflag;
					map[5][8].color=cflag;

					break;

				case PUZZLE_BLOCK_NO6:

					if( select == 0 )
					{
						map[3][8].flag=flag;
						map[4][6].flag=flag;
						map[4][7].flag=flag;
						map[4][8].flag=flag;
						map[5][6].flag=flag;
						map[5][7].flag=flag;
						map[5][8].flag=flag;

						map[3][8].color=cflag;
						map[4][6].color=cflag;
						map[4][7].color=cflag;
						map[4][8].color=cflag;
						map[5][6].color=cflag;
						map[5][7].color=cflag;
						map[5][8].color=cflag;
					}else
					{
						map[3][6].flag=flag;
						map[3][7].flag=flag;
						map[3][8].flag=flag;
						map[4][7].flag=flag;
						map[4][8].flag=flag;
						map[5][7].flag=flag;
						map[5][8].flag=flag;

						map[3][6].color=cflag;
						map[3][7].color=cflag;
						map[3][8].color=cflag;
						map[4][7].color=cflag;
						map[4][8].color=cflag;
						map[5][7].color=cflag;
						map[5][8].color=cflag;
					}

					break;

				case PUZZLE_BLOCK_NO7:

					map[3][8].flag=flag;
					map[4][6].flag=flag;
					map[4][7].flag=flag;
					map[4][8].flag=flag;
					map[5][8].flag=flag;

					map[3][8].color=cflag;
					map[4][6].color=cflag;
					map[4][7].color=cflag;
					map[4][8].color=cflag;
					map[5][8].color=cflag;

					break;
			}
			
			break;

		case BOTTOM:

			switch(tet->block_id)
			{
				case PUZZLE_BLOCK_NO1:

					map[7][4].flag=flag;
					map[7][5].flag=flag;
					map[8][4].flag=flag;
					map[8][5].flag=flag;

					map[7][4].color=cflag;
					map[7][5].color=cflag;
					map[8][4].color=cflag;
					map[8][5].color=cflag;

					break;

				case PUZZLE_BLOCK_NO2:

					if( select == 0 )
					{
						map[6][3].flag=flag;
						map[7][3].flag=flag;
						map[8][3].flag=flag;
						map[8][4].flag=flag;
						map[8][5].flag=flag;

						map[6][3].color=cflag;
						map[7][3].color=cflag;
						map[8][3].color=cflag;
						map[8][4].color=cflag;
						map[8][5].color=cflag;
					}else
					{
						map[6][5].flag=flag;
						map[7][5].flag=flag;
						map[8][3].flag=flag;
						map[8][4].flag=flag;
						map[8][5].flag=flag;

						map[6][5].color=cflag;
						map[7][5].color=cflag;
						map[8][3].color=cflag;
						map[8][4].color=cflag;
						map[8][5].color=cflag;
					}

					break;

				case PUZZLE_BLOCK_NO3:

					if( select == 0 )
					{
						map[8][3].flag=flag;
						map[8][4].flag=flag;
						map[8][5].flag=flag;

						map[8][3].color=cflag;
						map[8][4].color=cflag;
						map[8][5].color=cflag;
					}else
					{
						map[6][4].flag=flag;
						map[7][4].flag=flag;
						map[8][4].flag=flag;

						map[6][4].color=cflag;
						map[7][4].color=cflag;
						map[8][4].color=cflag;
					}

					break;

				case PUZZLE_BLOCK_NO4:

					map[7][4].flag=flag;
					map[8][3].flag=flag;
					map[8][4].flag=flag;
					map[8][5].flag=flag;

					map[7][4].color=cflag;
					map[8][3].color=cflag;
					map[8][4].color=cflag;
					map[8][5].color=cflag;

					break;

				case PUZZLE_BLOCK_NO5:

					map[7][3].flag=flag;
					map[7][5].flag=flag;
					map[8][3].flag=flag;
					map[8][4].flag=flag;
					map[8][5].flag=flag;

					map[7][3].color=cflag;
					map[7][5].color=cflag;
					map[8][3].color=cflag;
					map[8][4].color=cflag;
					map[8][5].color=cflag;

					break;

				case PUZZLE_BLOCK_NO6:

					if( select == 0 )
					{
						map[6][3].flag=flag;
						map[6][4].flag=flag;
						map[7][3].flag=flag;
						map[7][4].flag=flag;
						map[8][3].flag=flag;
						map[8][4].flag=flag;
						map[8][5].flag=flag;

						map[6][3].color=cflag;
						map[6][4].color=cflag;
						map[7][3].color=cflag;
						map[7][4].color=cflag;
						map[8][3].color=cflag;
						map[8][4].color=cflag;
						map[8][5].color=cflag;
					}else
					{
						map[6][5].flag=flag;
						map[7][3].flag=flag;
						map[7][4].flag=flag;
						map[7][5].flag=flag;
						map[8][3].flag=flag;
						map[8][4].flag=flag;
						map[8][5].flag=flag;

						map[6][5].color=cflag;
						map[7][3].color=cflag;
						map[7][4].color=cflag;
						map[7][5].color=cflag;
						map[8][3].color=cflag;
						map[8][4].color=cflag;
						map[8][5].color=cflag;
					}

					break;

				case PUZZLE_BLOCK_NO7:

					map[6][4].flag=flag;
					map[7][4].flag=flag;
					map[8][3].flag=flag;
					map[8][4].flag=flag;
					map[8][5].flag=flag;

					map[6][4].color=cflag;
					map[7][4].color=cflag;
					map[8][3].color=cflag;
					map[8][4].color=cflag;
					map[8][5].color=cflag;

					break;
			}

			break;

		case LEFT:

			switch(tet->block_id)
			{
				case PUZZLE_BLOCK_NO1:

					map[4][0].flag=flag;
					map[4][1].flag=flag;
					map[5][0].flag=flag;
					map[5][1].flag=flag;

					map[4][0].color=cflag;
					map[4][1].color=cflag;
					map[5][0].color=cflag;
					map[5][1].color=cflag;

					break;

				case PUZZLE_BLOCK_NO2:
					
					if( select == 0 )
					{
						map[3][0].flag=flag;
						map[3][1].flag=flag;
						map[3][2].flag=flag;
						map[4][0].flag=flag;
						map[5][0].flag=flag;

						map[3][0].color=cflag;
						map[3][1].color=cflag;
						map[3][2].color=cflag;
						map[4][0].color=cflag;
						map[5][0].color=cflag;
					}else
					{
						map[3][0].flag=flag;
						map[4][0].flag=flag;
						map[5][0].flag=flag;
						map[5][1].flag=flag;
						map[5][2].flag=flag;

						map[3][0].color=cflag;
						map[4][0].color=cflag;
						map[5][0].color=cflag;
						map[5][1].color=cflag;
						map[5][2].color=cflag;
					}

					break;

				case PUZZLE_BLOCK_NO3:

					if( select == 0 )
					{
						map[3][0].flag=flag;
						map[4][0].flag=flag;
						map[5][0].flag=flag;

						map[3][0].color=cflag;
						map[4][0].color=cflag;
						map[5][0].color=cflag;
					}else
					{
						map[4][0].flag=flag;
						map[4][1].flag=flag;
						map[4][2].flag=flag;

						map[4][0].color=cflag;
						map[4][1].color=cflag;
						map[4][2].color=cflag;
					}

					break;

				case PUZZLE_BLOCK_NO4:

					map[3][0].flag=flag;
					map[4][0].flag=flag;
					map[4][1].flag=flag;
					map[5][0].flag=flag;

					map[3][0].color=cflag;
					map[4][0].color=cflag;
					map[4][1].color=cflag;
					map[5][0].color=cflag;

					break;

				case PUZZLE_BLOCK_NO5:

					map[3][0].flag=flag;
					map[3][1].flag=flag;
					map[4][0].flag=flag;
					map[5][0].flag=flag;
					map[5][1].flag=flag;

					map[3][0].color=cflag;
					map[3][1].color=cflag;
					map[4][0].color=cflag;
					map[5][0].color=cflag;
					map[5][1].color=cflag;

					break;

				case PUZZLE_BLOCK_NO6:

					if( select == 0 )
					{
						map[3][0].flag=flag;
						map[3][1].flag=flag;
						map[3][2].flag=flag;
						map[4][0].flag=flag;
						map[4][1].flag=flag;
						map[4][2].flag=flag;
						map[5][0].flag=flag;

						map[3][0].color=cflag;
						map[3][1].color=cflag;
						map[3][2].color=cflag;
						map[4][0].color=cflag;
						map[4][1].color=cflag;
						map[4][2].color=cflag;
						map[5][0].color=cflag;
					}else
					{
						map[3][0].flag=flag;
						map[3][1].flag=flag;
						map[4][0].flag=flag;
						map[4][1].flag=flag;
						map[5][0].flag=flag;
						map[5][1].flag=flag;
						map[5][2].flag=flag;

						map[3][0].color=cflag;
						map[3][1].color=cflag;
						map[4][0].color=cflag;
						map[4][1].color=cflag;
						map[5][0].color=cflag;
						map[5][1].color=cflag;
						map[5][2].color=cflag;
					}

					break;

				case PUZZLE_BLOCK_NO7:

					map[3][0].flag=flag;
					map[4][0].flag=flag;
					map[4][1].flag=flag;
					map[4][2].flag=flag;
					map[5][0].flag=flag;

					map[3][0].color=cflag;
					map[4][0].color=cflag;
					map[4][1].color=cflag;
					map[4][2].color=cflag;
					map[5][0].color=cflag;

					break;
			}

			break;
	}


}

void display_puzzle_map(void)
{

	int i, j;
	int color;

	for( i=0 ; i < 9 ; i++ )
	{
		for( j=0 ; j < 9 ; j++ )
		{
			if( map[i][j].flag == 1 )
			{
				color=map[i][j].color;

				switch(color)
				{
					case COLOR_RED:

						display_image_to_fb(red_block, BLOCK_IMAGE_X_SIZE, BLOCK_IMAGE_Y_SIZE,
								map[i][j].x_offset, map[i][j].y_offset);
						break;

					case COLOR_GREEN:

						display_image_to_fb(green_block, BLOCK_IMAGE_X_SIZE, BLOCK_IMAGE_Y_SIZE,
								map[i][j].x_offset, map[i][j].y_offset);
						break;

					case COLOR_BLUE:

						display_image_to_fb(blue_block, BLOCK_IMAGE_X_SIZE, BLOCK_IMAGE_Y_SIZE,
								map[i][j].x_offset, map[i][j].y_offset);
						break;

					case COLOR_YELLOW:

						display_image_to_fb(yellow_block, BLOCK_IMAGE_X_SIZE, BLOCK_IMAGE_Y_SIZE,
								map[i][j].x_offset, map[i][j].y_offset);
						break;
				}
			}
		}
	}
}

void display_t_puzzle_image(void)
{
	display_image_to_fb(power, POWER_IMAGE_X_SIZE, POWER_IMAGE_Y_SIZE,
			POWER_X_OFFSET, POWER_Y_OFFSET);

	display_image_to_fb(info, INFO_IMAGE_X_SIZE, INFO_IMAGE_Y_SIZE,
			INFO_IMAGE_X_OFFSET, INFO_IMAGE_Y_OFFSET);

	display_puzzle_map();
}
/*
void display_t_puzzle_info_image(void)
{
	int ret;
	short ts_buf[4];
		
	display_image_to_fb(shock_manual, SHOCK_MANUAL_IMAGE_X_SIZE, SHOCK_MANUAL_IMAGE_Y_SIZE,
				SHOCK_MANUAL_IMAGE_X_OFFSET, SHOCK_MANUAL_IMAGE_Y_OFFSET);
	
	display_image_to_fb(stop, STOP_IMAGE_X_SIZE, STOP_IMAGE_Y_SIZE,
			STOP_IMAGE_X_OFFSET, STOP_IMAGE_Y_OFFSET);

	while(1)
	{
		ret=read(ts_fd, ts_buf, sizeof(ts_buf));
		if( ret < 0 )
		{
	    		printf("Read Touch Screen Data Error\n");
			exit(-1);
		}

		ret=check_click_zone(ts_buf[1], ts_buf[2]);

		if( ts_buf[0] && ret == STOP )
		{

			display_image_to_fb(stop_h, STOP_IMAGE_X_SIZE, STOP_IMAGE_Y_SIZE,
					STOP_IMAGE_X_OFFSET, STOP_IMAGE_Y_OFFSET);
				
			play_wav(click_wav, CLICK_WAV_SIZE);

			break;
		}
	}
}
*/

void *ts_thread_func(void *arg)
{	
	int ret;
	short ts_buf[4];
	
	while(1)
	{
		if(read(ts_fd,ts_buf,sizeof(ts_buf)) < 0)
		{
	    		printf("Read Touch Screen Data Error\n");
	    		cleanup();
		}	
		
		printf("Press[%d] X[%d] Y[%d] MillSec[%d]\n", ts_buf[0], ts_buf[1], ts_buf[2], ts_buf[3]);

		ret=check_click_zone(ts_buf[1], ts_buf[2]);
	
		if( ts_buf[0] )
		{
			
			switch( ret )
			{
				case POWER_OFF:

					display_image_to_fb(power_h, POWER_IMAGE_X_SIZE, POWER_IMAGE_Y_SIZE,
						POWER_X_OFFSET, POWER_Y_OFFSET);
				
					play_wav(power_wav, POWER_WAV_SIZE);

					display_image_to_fb(power, POWER_IMAGE_X_SIZE, POWER_IMAGE_Y_SIZE,
						POWER_X_OFFSET, POWER_Y_OFFSET);

					power_off=1;

				case INFO:
					
					display_image_to_fb(info_h, INFO_IMAGE_X_SIZE, INFO_IMAGE_Y_SIZE,
							INFO_IMAGE_X_OFFSET, INFO_IMAGE_Y_OFFSET);
					
					play_wav(info_wav, INFO_WAV_SIZE);

					//display_t_puzzle_info_image();

					//init_fb();

					//display_t_puzzle_image();
					
					break;

				default:

					break;
			}
		}
			
		usleep(100000);
	}
}

void *bt_thread_func(void *arg)
{
	while(1)
	{
		if(t_puzzle_complete)
		{
			bt_make_packet(&bt, BT_MASTER, BT_SLAVE, BT_CTL_TET);

			data=BT_CTL_TET_SET;

			bt_send(&bt, &data, sizeof(int));

			bt_recv(&bt, tet, sizeof(struct tet_block)*4);

			make_puzzle_map(tet);

			init_fb();

			display_t_puzzle_image();
		}
	}
}

int check_click_zone(short x, short y)
{
	if( x > 560 && x < 630 )
	{
		if( y > 16 && y < 86 )
			return POWER_OFF;
	}

	if( x > 16 && x < 86 )
	{
		if( y > 16 && y < 86 )
			return INFO;
	}

	if( x > 460 && x < 500 )
	{
		if( y > 320 && y < 360)
			return STOP;
	}

}
/*
void check_answer_block(int direction, int id, int cdir)
{
//ir_recv();
	printf("direction: %d id: %d cdir %d \ntet[2].block_id: %d tet[2].correct: %d tet[2].rot: %d", direction, id, cdir, tet[3].block_id, tet[3].correct, tet[3].rot);
	switch(direction)
	{
		case TOP:
			//tet[0].correct compare to target ir attached direction no
			if (id == tet[2].block_id && id == PUZZLE_BLOCK_NO1) {
				make_puzzle_block(TOP, &tet[2], 1);
				display_t_puzzle_image();
				t_puzzle_top = 1;
			} else if (id == tet[2].block_id &&
				    id == PUZZLE_BLOCK_NO3 &&
				    cdir%2 == (tet[2].correct+tet[2].rot) % 2) {
				make_puzzle_block(TOP, &tet[2], 1);
				display_t_puzzle_image();
				t_puzzle_top = 1;
			} else if (id == tet[2].block_id &&
				cdir == (tet[2].correct+tet[2].rot) % 4) {
				make_puzzle_block(TOP, &tet[2], 1);
				display_t_puzzle_image();
				t_puzzle_top = 1;
				printf("top\n");
			}
			else
			ir_send(incorrect);
			break;

		case RIGHT:
			//tet[1].correct compare
			if (id == tet[3].block_id && id == PUZZLE_BLOCK_NO1) {
				make_puzzle_block(RIGHT, &tet[3], 1);
				display_t_puzzle_image();
				t_puzzle_top = 1;
			} else if (id == tet[3].block_id &&
				    id == PUZZLE_BLOCK_NO3 &&
				    cdir%2 == (tet[3].correct+tet[3].rot) % 2) {
				make_puzzle_block(RIGHT, &tet[3], 1);
				display_t_puzzle_image();
				t_puzzle_top = 1;
			} else if (id == tet[3].block_id &&
				cdir == (tet[3].correct+tet[3].rot) % 4) {
				make_puzzle_block(RIGHT, &tet[3], 1);
				display_t_puzzle_image();
				t_puzzle_top = 1;
				printf("top\n");
			}

			else
			ir_send(incorrect);
			break;

		case BOTTOM:
			//tet[2].correct compare
			if (id == tet[0].block_id && id == PUZZLE_BLOCK_NO1) {
				make_puzzle_block(BOTTOM, &tet[0], 1);
				display_t_puzzle_image();
				t_puzzle_top = 1;
			} else if (id == tet[0].block_id &&
				    id == PUZZLE_BLOCK_NO3 &&
				    cdir%2 == (tet[0].correct+tet[0].rot) % 2) {
				make_puzzle_block(BOTTOM, &tet[0], 1);
				display_t_puzzle_image();
				t_puzzle_top = 1;
			} else if (id == tet[0].block_id &&
				cdir == (tet[0].correct+tet[0].rot) % 4) {
				make_puzzle_block(BOTTOM, &tet[0], 1);
				display_t_puzzle_image();
				t_puzzle_top = 1;
				printf("top\n");
			}

			else
			ir_send(incorrect);
			break;

		case LEFT:
			//tet[3].correct compare
			if (id == tet[1].block_id && id == PUZZLE_BLOCK_NO1) {
				make_puzzle_block(LEFT, &tet[1], 1);
				display_t_puzzle_image();
				t_puzzle_top = 1;
			} else if (id == tet[1].block_id &&
				    id == PUZZLE_BLOCK_NO3 &&
				    cdir%2 == (tet[1].correct+tet[1].rot) % 2) {
				make_puzzle_block(LEFT, &tet[1], 1);
				display_t_puzzle_image();
				t_puzzle_top = 1;
			} else if (id == tet[1].block_id &&
				cdir == (tet[1].correct+tet[1].rot) % 4) {
				make_puzzle_block(LEFT, &tet[1], 1);
				display_t_puzzle_image();
				t_puzzle_top = 1;
				printf("top\n");
			}

			else
			ir_send(incorrect);
			break;
	}
}
*/
void cleanup(void)
{
	init_fb();

	munmap(pfbdata, FB_SIZE*2);

	close(fb_fd);
	close(ts_fd);
	close(sound_fd);

	bt_exit();

	exit(1);
}
