#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <fcntl.h>
#include <time.h>
#include <signal.h>
#include <pthread.h>

#include <sys/ioctl.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/mman.h>
#include <sys/shm.h>

#include <linux/fb.h>

#define	CHO_CHAN_HO
//#define LEE_YUN_JAE
//#define KIM_DONG_UK
//#define SONG_WON_JUN
//#define LEE_DAE_GUN

#ifdef CHO_CHAN_HO
#define MODULE_ID	1
#define ACC_CAL_X	0.4
#define ACC_CAL_Y	0.5
#define ACC_CAL_Z	0
#endif

#ifdef LEE_YUN_JAE
#define MODULE_ID	2
#define ACC_CAL_X	0.4
#define ACC_CAL_Y	0.6
#define ACC_CAL_Z	0
#endif

#ifdef KIM_DONG_UK
#define MODULE_ID	3
#define ACC_CAL_X	0.4
#define ACC_CAL_Y	0.6
#define ACC_CAL_Z	0
#endif

#ifdef SONG_WON_JUN
#define MODULE_ID	4
#define ACC_CAL_X	0.4
#define ACC_CAL_Y	0.6
#define ACC_CAL_Z	0
#endif

#ifdef LEE_DAE_GUN
#define MODULE_ID	5
#define ACC_CAL_X	0.4
#define ACC_CAL_Y	0.6
#define ACC_CAL_Z	0
#endif

#define FB_DEV		"/dev/fb"
#define TS_DEV		"/dev/ts"
#define SOUND_DEV	"/dev/dsp"

#define XPOS1		0
#define YPOS1		0
#define XPOS2		640
#define YPOS2		480

#define FB_SIZE 	( XPOS2*YPOS2 )

#define POWER_IMAGE_PATH		"images/power.raw"
#define POWER_H_IMAGE_PATH		"images/power_h.raw"

#define INFO_IMAGE_PATH			"images/info.raw"
#define INFO_H_IMAGE_PATH		"images/info_h.raw"

#define NEXT_IMAGE_PATH			"images/next.raw"
#define NEXT_H_IMAGE_PATH		"images/next_h.raw"

#define STOP_IMAGE_PATH			"images/stop.raw"
#define STOP_H_IMAGE_PATH		"images/stop_h.raw"

#define POWER_WAV_PATH			"sound/shutdown.wav"
#define INFO_WAV_PATH			"sound/info.wav"
#define CLICK_WAV_PATH			"sound/click.wav"

#define LOADING_IMAGE1_PATH		"images/loading1.raw"
#define LOADING_IMAGE2_PATH		"images/loading2.raw"
#define LOADING_IMAGE3_PATH		"images/loading3.raw"
#define LOADING_IMAGE4_PATH		"images/loading4.raw"
#define LOADING_IMAGE5_PATH		"images/loading5.raw"
#define LOADING_IMAGE6_PATH		"images/loading6.raw"
#define LOADING_IMAGE7_PATH		"images/loading7.raw"
#define LOADING_IMAGE8_PATH		"images/loading8.raw"
#define LOADING_IMAGE9_PATH		"images/loading9.raw"
#define LOADING_IMAGE10_PATH		"images/loading10.raw"
#define LOADING_IMAGE11_PATH		"images/loading11.raw"
#define LOADING_IMAGE12_PATH		"images/loading12.raw"
#define LOADING_IMAGE13_PATH		"images/loading13.raw"

#define POWER_IMAGE_X_SIZE		70
#define POWER_IMAGE_Y_SIZE		70

#define INFO_IMAGE_X_SIZE		70
#define INFO_IMAGE_Y_SIZE		70

#define NEXT_IMAGE_X_SIZE		40
#define NEXT_IMAGE_Y_SIZE		40

#define STOP_IMAGE_X_SIZE		40
#define STOP_IMAGE_Y_SIZE		40

#define LOADING_IMAGE_X_SIZE		100
#define LOADING_IMAGE_Y_SIZE		110

#define POWER_X_OFFSET			560
#define POWER_Y_OFFSET			16

#define INFO_IMAGE_X_OFFSET		16
#define INFO_IMAGE_Y_OFFSET		16

#define NEXT_IMAGE_X_OFFSET		460
#define NEXT_IMAGE_Y_OFFSET		320

#define STOP_IMAGE_X_OFFSET		460
#define STOP_IMAGE_Y_OFFSET		320

#define LOADING_IMAGE_X_OFFSET		270
#define LOADING_IMAGE_Y_OFFSET		185

#define POWER_IMAGE_SIZE		( POWER_IMAGE_X_SIZE * POWER_IMAGE_Y_SIZE )
#define INFO_IMAGE_SIZE			( INFO_IMAGE_X_SIZE * INFO_IMAGE_Y_SIZE )
#define NEXT_IMAGE_SIZE			( NEXT_IMAGE_X_SIZE * NEXT_IMAGE_Y_SIZE )
#define STOP_IMAGE_SIZE			( STOP_IMAGE_X_SIZE * STOP_IMAGE_Y_SIZE )
#define LOADING_IMAGE_SIZE		( LOADING_IMAGE_X_SIZE * LOADING_IMAGE_Y_SIZE )
#define POWER_WAV_SIZE			368684
#define CLICK_WAV_SIZE			85548
#define INFO_WAV_SIZE			170588

typedef unsigned char ubyte;

int fb_fd;
int ts_fd;
int sound_fd;
int load_complete_flag=0;
unsigned short *pfbdata;
unsigned short power[POWER_IMAGE_SIZE];
unsigned short power_h[POWER_IMAGE_SIZE];
unsigned short info[INFO_IMAGE_SIZE];
unsigned short info_h[INFO_IMAGE_SIZE];
unsigned short next[NEXT_IMAGE_SIZE];
unsigned short next_h[NEXT_IMAGE_SIZE];
unsigned short stop[STOP_IMAGE_SIZE];
unsigned short stop_h[STOP_IMAGE_SIZE];
unsigned short loading[13][LOADING_IMAGE_SIZE];

unsigned char power_wav[POWER_WAV_SIZE];
unsigned char info_wav[INFO_WAV_SIZE];
unsigned char click_wav[CLICK_WAV_SIZE];

pthread_t load_thread;

unsigned short makepixel(ubyte r, ubyte g, ubyte b)
{
    return (unsigned short) ((( r >> 3 ) <<11 | ( g >> 2 ) << 5 ) | ( b >> 3 ));
}

void init_fb(void)
{
	int x ,y;
	int offset;
	int pixel;
	
	pixel=makepixel(0, 0, 0);

	for(y=YPOS1 ; y < YPOS2 ;y++)
	{
		offset=y*XPOS2;
		for(x=XPOS1 ; x < XPOS2 ;x++)
		{
			*(pfbdata+offset+x)=pixel;
		}
	}
}



int open_image(const char *image_path)
{
	int fd;

	fd=open(image_path, O_RDONLY);
	if( fd < 0 )
	{
		printf("%s open failed\n", image_path);
		exit(-1);
	}

	return fd;
}

int open_wav(const char *wav_path)
{
	int fd;

	fd=open(wav_path, O_RDONLY);
	if( fd < 0 )
	{
		printf("%s open failed\n", wav_path);
		exit(-1);
	}

	return fd;
}

int copy_image_to_buff(int fd, unsigned short *buf, int size)
{
	int index=0;
	unsigned short pixel;
	//ubyte r, g, b;
	int ret=0;

	while(index < size)
	{
		//read(fd, &pixel, 2);
		//read(fd, &g, 1);
		//read(fd, &b, 1);

		//pixel=makepixel(r, g, b);

		read(fd, buf, size*2);

		index++;
		ret++;
	}

	return ret;
}

int copy_wav_to_buff(int fd, unsigned char *buf, int size)
{
	int ret;

	ret=read(fd, buf, size);

	if( ret < 0 )
	{
		printf("Raea WAV file failed\n");
		return -1;
	}

	return ret;
}

int display_image_to_fb(unsigned short *image, int x_size, int y_size, int x_offset, int y_offset)
{
	int x, y;
	int image_index;
	int start_offset;

	image_index=0;
	start_offset=640*y_offset+x_offset;

	for(y=0 ; y < y_size ; y++)
	{
		for(x=0 ; x < x_size ; x++)
		{
			//printf("%d",image[image_index]);
			*(pfbdata+start_offset+x)=image[image_index];
			image_index++;
		}

		start_offset=start_offset+640;
		printf("\n");
	}

	return image_index;
}

int play_wav(char *wav_buf, int size)
{
	int ret;

	ret=write(sound_fd, wav_buf, size);

	return ret;
}

void init_loading_image(void)
{
	int fd;

	fd=open_image(LOADING_IMAGE1_PATH);
	copy_image_to_buff(fd, loading[0], LOADING_IMAGE_SIZE);
	close(fd);
	
	fd=open_image(LOADING_IMAGE2_PATH);
	copy_image_to_buff(fd, loading[1], LOADING_IMAGE_SIZE);
	close(fd);

	fd=open_image(LOADING_IMAGE3_PATH);
	copy_image_to_buff(fd, loading[2], LOADING_IMAGE_SIZE);
	close(fd);

	fd=open_image(LOADING_IMAGE4_PATH);
	copy_image_to_buff(fd, loading[3], LOADING_IMAGE_SIZE);
	close(fd);

	fd=open_image(LOADING_IMAGE5_PATH);
	copy_image_to_buff(fd, loading[4], LOADING_IMAGE_SIZE);
	close(fd);

	fd=open_image(LOADING_IMAGE6_PATH);
	copy_image_to_buff(fd, loading[5], LOADING_IMAGE_SIZE);
	close(fd);

	fd=open_image(LOADING_IMAGE7_PATH);
	copy_image_to_buff(fd, loading[6], LOADING_IMAGE_SIZE);
	close(fd);

	fd=open_image(LOADING_IMAGE8_PATH);
	copy_image_to_buff(fd, loading[7], LOADING_IMAGE_SIZE);
	close(fd);

	fd=open_image(LOADING_IMAGE9_PATH);
	copy_image_to_buff(fd, loading[8], LOADING_IMAGE_SIZE);
	close(fd);

	fd=open_image(LOADING_IMAGE10_PATH);
	copy_image_to_buff(fd, loading[9], LOADING_IMAGE_SIZE);
	close(fd);

	fd=open_image(LOADING_IMAGE11_PATH);
	copy_image_to_buff(fd, loading[10], LOADING_IMAGE_SIZE);
	close(fd);

	fd=open_image(LOADING_IMAGE12_PATH);
	copy_image_to_buff(fd, loading[11], LOADING_IMAGE_SIZE);
	close(fd);

	fd=open_image(LOADING_IMAGE13_PATH);
	copy_image_to_buff(fd, loading[12], LOADING_IMAGE_SIZE);
	close(fd);
}

void *load_thread_func(void *arg)
{
	int index=0;

	while(1)
	{
		display_image_to_fb(loading[index], LOADING_IMAGE_X_SIZE, LOADING_IMAGE_Y_SIZE,
				LOADING_IMAGE_X_OFFSET, LOADING_IMAGE_Y_OFFSET);
		
		if( index == 12 )
			index=0;
		else
			index++;

		if( load_complete_flag == 1)
			break;

		usleep(100000);
	}

	pthread_exit(0);
}

void error_handle(const char *msg)
{
	fputs(msg, stderr);
	fputc('\n', stderr);

	exit(1);
}
